/*     */ package com.jaspersoft.jasperserver.api.engine.scheduling.domain;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.api.JasperServerAPI;
/*     */ import com.jaspersoft.jasperserver.api.engine.scheduling.domain.jaxb.FtpTypeAdapter;
/*     */ import java.io.Serializable;
/*     */ import java.util.HashMap;
/*     */ import java.util.Map;
/*     */ import javax.xml.bind.annotation.XmlRootElement;
/*     */ import javax.xml.bind.annotation.XmlTransient;
/*     */ import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ @JasperServerAPI
/*     */ @XmlRootElement
/*     */ public class FTPInfo
/*     */   implements Serializable
/*     */ {
/*     */   private static final long serialVersionUID = 1L;
/*     */   String userName;
/*     */   String password;
/*     */   String folderPath;
/*     */   String serverName;
/*     */   private volatile Map<String, String> propertiesMap;
/*  50 */   private static String FTP_TYPE_PROPERTY = "FTP_TYPE_PROPERTY";
/*  51 */   private static String PORT_PROPERTY = "PORT_PROPERTY";
/*  52 */   private static String PROTOCOL_PROPERTY = "PROTOCOL_PROPERTY";
/*  53 */   private static String IS_IMPLICIT_PROPERTY = "IS_IMPLICIT_PROPERTY";
/*  54 */   private static String PHSZ_PROPERTY = "PHSZ_PROPERTY";
/*  55 */   private static String PROT_PROPERTY = "PROT_PROPERTY";
/*     */   
/*  57 */   public static String TYPE_FTP = "TYPE_FTP";
/*  58 */   public static String TYPE_FTPS = "TYPE_FTPS";
/*     */   
/*     */ 
/*     */ 
/*     */   public FTPInfo() {}
/*     */   
/*     */ 
/*     */   public FTPInfo(FTPInfo source)
/*     */   {
/*  67 */     setUserName(source.getUserName());
/*  68 */     setPassword(source.getPassword());
/*  69 */     setFolderPath(source.getFolderPath());
/*  70 */     setServerName(source.getServerName());
/*  71 */     if (source.getPropertiesMap() != null) {
/*  72 */       setPropertiesMap(new HashMap(source.getPropertiesMap()));
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getUserName()
/*     */   {
/*  82 */     return this.userName;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setUserName(String userName)
/*     */   {
/*  91 */     this.userName = ((userName != null) && (!userName.isEmpty()) ? userName : "anonymous");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getPassword()
/*     */   {
/* 100 */     return this.password;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setPassword(String password)
/*     */   {
/* 109 */     this.password = password;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getFolderPath()
/*     */   {
/* 119 */     return this.folderPath;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setFolderPath(String folderPath)
/*     */   {
/* 129 */     this.folderPath = folderPath;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getServerName()
/*     */   {
/* 138 */     return this.serverName;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setServerName(String serverName)
/*     */   {
/* 147 */     this.serverName = serverName;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @XmlJavaTypeAdapter(FtpTypeAdapter.class)
/*     */   public String getType()
/*     */   {
/* 158 */     String prop = null;
/* 159 */     if (this.propertiesMap != null) prop = (String)this.propertiesMap.get(FTP_TYPE_PROPERTY);
/* 160 */     if (prop == null) return TYPE_FTPS;
/* 161 */     return prop;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setType(String type)
/*     */   {
/* 171 */     setProperty(FTP_TYPE_PROPERTY, type);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public int getPort()
/*     */   {
/* 180 */     String prop = null;
/* 181 */     if (this.propertiesMap != null) prop = (String)this.propertiesMap.get(PORT_PROPERTY);
/* 182 */     if (prop != null) return Integer.parseInt(prop);
/* 183 */     if (getType().equals(TYPE_FTPS)) return 990;
/* 184 */     return 21;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setPort(int port)
/*     */   {
/* 193 */     setProperty(PORT_PROPERTY, port + "");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getProtocol()
/*     */   {
/* 202 */     if (this.propertiesMap == null) return null;
/* 203 */     return (String)this.propertiesMap.get(PROTOCOL_PROPERTY);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setProtocol(String protocol)
/*     */   {
/* 212 */     setProperty(PROTOCOL_PROPERTY, protocol);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean isImplicit()
/*     */   {
/* 222 */     if (this.propertiesMap == null) return true;
/* 223 */     String prop = (String)this.propertiesMap.get(IS_IMPLICIT_PROPERTY);
/* 224 */     if (prop != null) return Boolean.parseBoolean(prop);
/* 225 */     return true;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setImplicit(boolean implicit)
/*     */   {
/* 235 */     setProperty(IS_IMPLICIT_PROPERTY, implicit + "");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public long getPbsz()
/*     */   {
/* 244 */     if (this.propertiesMap == null) return 0L;
/* 245 */     String prop = (String)this.propertiesMap.get(PHSZ_PROPERTY);
/* 246 */     if (prop != null) return Long.parseLong(prop);
/* 247 */     return 0L;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setPbsz(long pbsz)
/*     */   {
/* 256 */     setProperty(PHSZ_PROPERTY, pbsz + "");
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getProt()
/*     */   {
/* 271 */     if (this.propertiesMap == null) return null;
/* 272 */     return (String)this.propertiesMap.get(PROT_PROPERTY);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setProt(String prot)
/*     */   {
/* 287 */     setProperty(PROT_PROPERTY, prot);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @XmlTransient
/*     */   public Map<String, String> getPropertiesMap()
/*     */   {
/* 297 */     return this.propertiesMap;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setPropertiesMap(Map<String, String> propertiesMap)
/*     */   {
/* 306 */     this.propertiesMap = propertiesMap;
/*     */   }
/*     */   
/*     */   protected void setProperty(String propertyName, String propertyValue) {
/* 310 */     if (this.propertiesMap == null) {
/* 311 */       synchronized (this) {
/* 312 */         if (this.propertiesMap == null) {
/* 313 */           this.propertiesMap = new HashMap();
/*     */         }
/*     */       }
/*     */     }
/* 317 */     if (propertyValue == null) {
/* 318 */       this.propertiesMap.remove(propertyName);
/*     */     } else {
/* 320 */       this.propertiesMap.put(propertyName, propertyValue);
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-api-engine-6.0.jar!\com\jaspersoft\jasperserver\api\engine\scheduling\domain\FTPInfo.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */