/*     */ package com.jaspersoft.jasperserver.api.engine.scheduling.domain;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.api.JSException;
/*     */ import com.jaspersoft.jasperserver.api.JasperServerAPI;
/*     */ import com.jaspersoft.jasperserver.api.engine.scheduling.domain.jaxb.OutputFormatXmlAdapter;
/*     */ import com.jaspersoft.jasperserver.api.engine.scheduling.domain.jaxb.TimestampToStringXmlAdapter;
/*     */ import java.io.Serializable;
/*     */ import java.sql.Timestamp;
/*     */ import java.util.Calendar;
/*     */ import java.util.GregorianCalendar;
/*     */ import java.util.HashMap;
/*     */ import java.util.HashSet;
/*     */ import java.util.Map;
/*     */ import java.util.Set;
/*     */ import java.util.TimeZone;
/*     */ import javax.xml.bind.annotation.XmlElement;
/*     */ import javax.xml.bind.annotation.XmlElements;
/*     */ import javax.xml.bind.annotation.XmlRootElement;
/*     */ import javax.xml.bind.annotation.XmlTransient;
/*     */ import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;
/*     */ import org.apache.commons.lang.StringUtils;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ @JasperServerAPI
/*     */ @XmlRootElement(name="job")
/*     */ public class ReportJob
/*     */   implements Serializable
/*     */ {
/*     */   private static final long serialVersionUID = 1L;
/*     */   public static final int VERSION_NEW = -1;
/*     */   public static final byte OUTPUT_FORMAT_PDF = 1;
/*     */   public static final byte OUTPUT_FORMAT_HTML = 2;
/*     */   public static final byte OUTPUT_FORMAT_XLS = 3;
/*     */   public static final byte OUTPUT_FORMAT_RTF = 4;
/*     */   public static final byte OUTPUT_FORMAT_CSV = 5;
/*     */   public static final byte OUTPUT_FORMAT_ODT = 6;
/*     */   public static final byte OUTPUT_FORMAT_TXT = 7;
/*     */   public static final byte OUTPUT_FORMAT_DOCX = 8;
/*     */   public static final byte OUTPUT_FORMAT_ODS = 9;
/*     */   public static final byte OUTPUT_FORMAT_XLSX = 10;
/*     */   public static final byte OUTPUT_FORMAT_XLS_NOPAG = 11;
/*     */   public static final byte OUTPUT_FORMAT_XLSX_NOPAG = 12;
/*     */   public static final byte OUTPUT_FORMAT_PPTX = 14;
/*     */   public static final byte OUTPUT_FORMAT_DATA_SNAPSHOT = 100;
/*     */   private long id;
/* 177 */   private int version = -1;
/*     */   
/*     */   private String username;
/*     */   
/*     */   private String label;
/*     */   private String description;
/*     */   private Timestamp creationDate;
/*     */   private ReportJobTrigger trigger;
/*     */   private ReportJobSource source;
/*     */   private String baseOutputFilename;
/*     */   private Set<Byte> outputFormats;
/*     */   private String outputLocale;
/*     */   private ReportJobRepositoryDestination contentRepositoryDestination;
/*     */   private ReportJobMailNotification mailNotification;
/*     */   private ReportJobAlert alert;
/*     */   
/*     */   public ReportJob()
/*     */   {
/* 195 */     this.outputFormats = new HashSet();
/* 196 */     this.creationDate = new Timestamp(GregorianCalendar.getInstance().getTimeInMillis());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public long getId()
/*     */   {
/* 209 */     return this.id;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setId(long id)
/*     */   {
/* 224 */     this.id = id;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public int getVersion()
/*     */   {
/* 242 */     return this.version;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setVersion(int version)
/*     */   {
/* 266 */     this.version = version;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ReportJobSource getSource()
/*     */   {
/* 278 */     return this.source;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setSource(ReportJobSource source)
/*     */   {
/* 291 */     this.source = source;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @XmlElements({@XmlElement(name="simpleTrigger", type=ReportJobSimpleTrigger.class), @XmlElement(name="calendarTrigger", type=ReportJobCalendarTrigger.class)})
/*     */   public ReportJobTrigger getTrigger()
/*     */   {
/* 305 */     return this.trigger;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setTrigger(ReportJobTrigger trigger)
/*     */   {
/* 322 */     this.trigger = trigger;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ReportJobMailNotification getMailNotification()
/*     */   {
/* 334 */     return this.mailNotification;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setMailNotification(ReportJobMailNotification mailNotification)
/*     */   {
/* 347 */     if ((this.contentRepositoryDestination != null) && (!this.contentRepositoryDestination.isSaveToRepository()) && (mailNotification != null) && (mailNotification.getResultSendTypeCode().byteValue() == 1))
/*     */     {
/* 349 */       throw new JSException("Cannot send mail notifications contain links of the job output in repository when saving to repository function is disabled.");
/*     */     }
/* 351 */     this.mailNotification = mailNotification;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @XmlElement(name="repositoryDestination")
/*     */   public ReportJobRepositoryDestination getContentRepositoryDestination()
/*     */   {
/* 369 */     return this.contentRepositoryDestination;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setContentRepositoryDestination(ReportJobRepositoryDestination contentRepositoryDestination)
/*     */   {
/* 385 */     if ((contentRepositoryDestination != null) && (!contentRepositoryDestination.isSaveToRepository()) && (this.mailNotification != null) && (this.mailNotification.getResultSendTypeCode().byteValue() == 1))
/*     */     {
/* 387 */       throw new JSException("Cannot send mail notifications contain links of the job output in repository when saving to repository function is disabled.");
/*     */     }
/* 389 */     this.contentRepositoryDestination = contentRepositoryDestination;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ReportJobAlert getAlert()
/*     */   {
/* 401 */     return this.alert;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setAlert(ReportJobAlert alert)
/*     */   {
/* 414 */     this.alert = alert;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getDescription()
/*     */   {
/* 423 */     return this.description;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setDescription(String description)
/*     */   {
/* 432 */     this.description = description;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @XmlJavaTypeAdapter(TimestampToStringXmlAdapter.class)
/*     */   public Timestamp getCreationDate()
/*     */   {
/* 443 */     return this.creationDate;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setCreationDate(Timestamp creationDate)
/*     */   {
/* 453 */     this.creationDate = creationDate;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getLabel()
/*     */   {
/* 462 */     return this.label;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setLabel(String label)
/*     */   {
/* 471 */     this.label = label;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getBaseOutputFilename()
/*     */   {
/* 487 */     return this.baseOutputFilename;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setBaseOutputFilename(String baseOutputFilename)
/*     */   {
/* 497 */     this.baseOutputFilename = baseOutputFilename;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   @XmlTransient
/*     */   public Set getOutputFormats()
/*     */   {
/* 514 */     return getOutputFormatsSet();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   @XmlElement(name="outputFormats")
/*     */   @XmlJavaTypeAdapter(OutputFormatXmlAdapter.class)
/*     */   public Set<Byte> getOutputFormatsSet()
/*     */   {
/* 531 */     return this.outputFormats;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   /**
/*     */    * @deprecated
/*     */    */
/*     */   public void setOutputFormats(Set outputFormats)
/*     */   {
/* 543 */     setOutputFormatsSet(outputFormats);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setOutputFormatsSet(Set<Byte> outputFormats)
/*     */   {
/* 554 */     this.outputFormats = outputFormats;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean addOutputFormat(byte outputFormat)
/*     */   {
/* 565 */     return this.outputFormats.add(Byte.valueOf(outputFormat));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean removeOutputFormat(byte outputFormat)
/*     */   {
/* 575 */     return this.outputFormats.remove(new Byte(outputFormat));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getUsername()
/*     */   {
/* 590 */     return this.username;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setUsername(String username)
/*     */   {
/* 605 */     this.username = username;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getOutputLocale()
/*     */   {
/* 618 */     return this.outputLocale;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setOutputLocale(String outputLocale)
/*     */   {
/* 631 */     this.outputLocale = outputLocale;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean equals(ReportJob rj)
/*     */   {
/* 642 */     return (this.label.equals(rj.getLabel())) && (this.username.equals(rj.getUsername())) && (this.baseOutputFilename.equals(rj.getBaseOutputFilename())) && (this.trigger.equals(rj.getTrigger()));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public String getOutputTimeZone()
/*     */   {
/* 657 */     ReportJobSource jobSource = getSource();
/* 658 */     if (jobSource != null)
/*     */     {
/* 660 */       Map<String, Object> parameters = jobSource.getParameters();
/* 661 */       if (parameters != null) {
/* 662 */         TimeZone tz = (TimeZone)parameters.get("REPORT_TIME_ZONE");
/* 663 */         return tz != null ? tz.getID() : null;
/*     */       }
/*     */     }
/*     */     
/* 667 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setOutputTimeZone(String timeZoneID)
/*     */   {
/* 679 */     ReportJobSource jobSource = getSource();
/* 680 */     if ((jobSource != null) && (!StringUtils.isEmpty(timeZoneID)))
/*     */     {
/* 682 */       Map<String, Object> parameters = jobSource.getParameters();
/* 683 */       if (parameters == null) {
/* 684 */         parameters = new HashMap();
/* 685 */         jobSource.setParameters(parameters);
/*     */       }
/*     */       
/* 688 */       parameters.put("REPORT_TIME_ZONE", TimeZone.getTimeZone(timeZoneID));
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void setReportParameters(Map<String, Object> values)
/*     */   {
/* 699 */     ReportJobSource jobSource = getSource();
/* 700 */     if (jobSource != null) {
/* 701 */       Map<String, Object> parameters = jobSource.getParameters();
/* 702 */       if (parameters != null) {
/* 703 */         parameters.putAll(values);
/*     */       } else {
/* 705 */         jobSource.setParameters(values);
/*     */       }
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ReportJob(ReportJob job)
/*     */   {
/* 729 */     setVersion(-1);
/* 730 */     setSource(new ReportJobSource(job.getSource()));
/* 731 */     ReportJobTrigger trigger = job.getTrigger();
/* 732 */     if (trigger != null) {
/* 733 */       if ((trigger instanceof ReportJobCalendarTrigger)) {
/* 734 */         setTrigger(new ReportJobCalendarTrigger((ReportJobCalendarTrigger)trigger));
/*     */       }
/* 736 */       else if ((trigger instanceof ReportJobSimpleTrigger)) {
/* 737 */         setTrigger(new ReportJobSimpleTrigger((ReportJobSimpleTrigger)trigger));
/*     */       }
/*     */       else {
/* 740 */         throw new JSException("ERROR !  Unhandled Trigger type '" + trigger.getClass().getName() + "'");
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 745 */     if (job.getMailNotification() != null) {
/* 746 */       setMailNotification(new ReportJobMailNotification(job.getMailNotification()));
/*     */     } else {
/* 748 */       setMailNotification(null);
/*     */     }
/* 750 */     setContentRepositoryDestination(new ReportJobRepositoryDestination(job.getContentRepositoryDestination()));
/* 751 */     setDescription(job.getDescription());
/* 752 */     setCreationDate(job.getCreationDate());
/* 753 */     setLabel(job.getLabel());
/* 754 */     setBaseOutputFilename(job.getBaseOutputFilename());
/* 755 */     setOutputFormats(new HashSet(job.getOutputFormats()));
/* 756 */     setOutputFormatsSet(new HashSet(job.getOutputFormatsSet()));
/* 757 */     setUsername(job.getUsername());
/* 758 */     setOutputLocale(job.getOutputLocale());
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-api-engine-6.0.jar!\com\jaspersoft\jasperserver\api\engine\scheduling\domain\ReportJob.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */