/*     */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.importexport.exportservice;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.importexport.ExportTaskDto;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.importexport.StateDto;
/*     */ import java.util.ArrayList;
/*     */ import java.util.List;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ExportTaskAdapter
/*     */   extends AbstractAdapter
/*     */ {
/*     */   private final ExportTaskDto exportTaskDto;
/*     */   
/*     */   public ExportTaskAdapter(SessionStorage sessionStorage)
/*     */   {
/*  41 */     super(sessionStorage);
/*  42 */     this.exportTaskDto = new ExportTaskDto();
/*  43 */     this.exportTaskDto.setParameters(new ArrayList());
/*  44 */     this.exportTaskDto.setRoles(new ArrayList());
/*  45 */     this.exportTaskDto.setUsers(new ArrayList());
/*  46 */     this.exportTaskDto.setUris(new ArrayList());
/*     */   }
/*     */   
/*     */   public ExportTaskAdapter role(String role) {
/*  50 */     this.exportTaskDto.getRoles().add(role);
/*  51 */     return this;
/*     */   }
/*     */   
/*     */   public ExportTaskAdapter roles(List<String> roles) {
/*  55 */     this.exportTaskDto.getRoles().addAll(roles);
/*  56 */     return this;
/*     */   }
/*     */   
/*     */   public ExportTaskAdapter user(String user) {
/*  60 */     this.exportTaskDto.getUsers().add(user);
/*  61 */     return this;
/*     */   }
/*     */   
/*     */   public ExportTaskAdapter users(List<String> users) {
/*  65 */     this.exportTaskDto.getUsers().addAll(users);
/*  66 */     return this;
/*     */   }
/*     */   
/*     */   public ExportTaskAdapter uri(String uri) {
/*  70 */     this.exportTaskDto.getUris().add(uri);
/*  71 */     return this;
/*     */   }
/*     */   
/*     */   public ExportTaskAdapter uris(List<String> uris) {
/*  75 */     this.exportTaskDto.getUris().addAll(uris);
/*  76 */     return this;
/*     */   }
/*     */   
/*     */   public ExportTaskAdapter parameter(ExportParameter parameter) {
/*  80 */     this.exportTaskDto.getParameters().add(parameter.getParamName());
/*  81 */     return this;
/*     */   }
/*     */   
/*     */   public ExportTaskAdapter parameters(List<ExportParameter> parameters) {
/*  85 */     for (ExportParameter exportParameter : parameters) {
/*  86 */       parameter(exportParameter);
/*     */     }
/*  88 */     return this;
/*     */   }
/*     */   
/*     */   public OperationResult<StateDto> create() {
/*  92 */     return JerseyRequest.buildRequest(this.sessionStorage, StateDto.class, new String[] { "/export" }, new DefaultErrorHandler()).post(this.exportTaskDto);
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncCreate(final Callback<OperationResult<StateDto>, R> callback)
/*     */   {
/*  97 */     final JerseyRequest<StateDto> request = JerseyRequest.buildRequest(this.sessionStorage, StateDto.class, new String[] { "/export" });
/*  98 */     request.setAccept("application/zip");
/*     */     
/* 100 */     final ExportTaskDto localCopy = new ExportTaskDto(this.exportTaskDto);
/* 101 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 104 */         callback.execute(request.post(localCopy));
/*     */       }
/* 106 */     });
/* 107 */     ThreadPoolUtil.runAsynchronously(task);
/* 108 */     return task;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\importexport\exportservice\ExportTaskAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */