/*     */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.jobs.calendar;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.WithEntityOperationResult;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.ReportJobCalendar;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.calendars.AnnualCalendar;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.calendars.BaseCalendar;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.calendars.Calendar;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.calendars.CronCalendar;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.calendars.DailyCalendar;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.calendars.HolidayCalendar;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.calendars.MonthlyCalendar;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.dto.jobs.calendars.WeeklyCalendar;
/*     */ import javax.ws.rs.core.MultivaluedHashMap;
/*     */ import javax.ws.rs.core.MultivaluedMap;
/*     */ import javax.ws.rs.core.Response;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SingleCalendarOperationsAdapter
/*     */   extends AbstractAdapter
/*     */ {
/*     */   private final String calendarName;
/*     */   private final MultivaluedMap<String, String> params;
/*     */   
/*     */   public SingleCalendarOperationsAdapter(SessionStorage sessionStorage, String calendarName)
/*     */   {
/*  41 */     super(sessionStorage);
/*  42 */     this.calendarName = calendarName;
/*  43 */     this.params = new MultivaluedHashMap();
/*     */   }
/*     */   
/*     */   public SingleCalendarOperationsAdapter parameter(CalendarParameter parameter, String value) {
/*  47 */     this.params.add(parameter.getName(), value);
/*  48 */     return this;
/*     */   }
/*     */   
/*     */   public OperationResult<Calendar> get() {
/*  52 */     OperationResult<ReportJobCalendar> result = JerseyRequest.buildRequest(this.sessionStorage, ReportJobCalendar.class, new String[] { "/jobs", "/calendars", this.calendarName }).get();
/*  53 */     return convertToLocalCalendarType(result);
/*     */   }
/*     */   
/*     */   private OperationResult<Calendar> convertToLocalCalendarType(OperationResult<ReportJobCalendar> source) {
/*  57 */     ReportJobCalendar reportJobCalendar = (ReportJobCalendar)source.getEntity();
/*  58 */     CalendarType calendarType = CalendarType.valueOf(reportJobCalendar.getCalendarType());
/*  59 */     Calendar localCalendar = null;
/*  60 */     switch (calendarType) {
/*     */     case annual: 
/*  62 */       AnnualCalendar annualCalendar = new AnnualCalendar();
/*  63 */       setCommonCalendarFields(annualCalendar, reportJobCalendar);
/*  64 */       annualCalendar.setDataSorted(reportJobCalendar.isDataSorted());
/*  65 */       annualCalendar.setExcludeDays(reportJobCalendar.getExcludeDays());
/*  66 */       localCalendar = annualCalendar;
/*  67 */       break;
/*     */     
/*     */     case base: 
/*  70 */       BaseCalendar baseCalendar = new BaseCalendar();
/*  71 */       setCommonCalendarFields(baseCalendar, reportJobCalendar);
/*  72 */       localCalendar = baseCalendar;
/*  73 */       break;
/*     */     
/*     */     case cron: 
/*  76 */       CronCalendar cronCalendar = new CronCalendar();
/*  77 */       setCommonCalendarFields(cronCalendar, reportJobCalendar);
/*  78 */       cronCalendar.setCronExpression(reportJobCalendar.getCronExpression());
/*  79 */       localCalendar = cronCalendar;
/*  80 */       break;
/*     */     
/*     */     case daily: 
/*  83 */       DailyCalendar dailyCalendar = new DailyCalendar();
/*  84 */       setCommonCalendarFields(dailyCalendar, reportJobCalendar);
/*  85 */       dailyCalendar.setInvertTimeRange(reportJobCalendar.isInvertTimeRange());
/*  86 */       dailyCalendar.setRangeEndingCalendar(reportJobCalendar.getRangeEndingCalendar());
/*  87 */       dailyCalendar.setRangeStartingCalendar(reportJobCalendar.getRangeStartingCalendar());
/*  88 */       localCalendar = dailyCalendar;
/*  89 */       break;
/*     */     
/*     */     case holiday: 
/*  92 */       HolidayCalendar holidayCalendar = new HolidayCalendar();
/*  93 */       setCommonCalendarFields(holidayCalendar, reportJobCalendar);
/*  94 */       holidayCalendar.setDataSorted(reportJobCalendar.isDataSorted());
/*  95 */       holidayCalendar.setExcludeDays(reportJobCalendar.getExcludeDays());
/*  96 */       localCalendar = holidayCalendar;
/*  97 */       break;
/*     */     
/*     */     case monthly: 
/* 100 */       MonthlyCalendar monthlyCalendar = new MonthlyCalendar();
/* 101 */       setCommonCalendarFields(monthlyCalendar, reportJobCalendar);
/* 102 */       monthlyCalendar.setExcludeDaysFlags(reportJobCalendar.getExcludeDaysFlags());
/* 103 */       localCalendar = monthlyCalendar;
/* 104 */       break;
/*     */     
/*     */     case weekly: 
/* 107 */       WeeklyCalendar weeklyCalendar = new WeeklyCalendar();
/* 108 */       setCommonCalendarFields(weeklyCalendar, reportJobCalendar);
/* 109 */       weeklyCalendar.setExcludeDaysFlags(reportJobCalendar.getExcludeDaysFlags());
/* 110 */       localCalendar = weeklyCalendar;
/* 111 */       break;
/*     */     }
/*     */     
/* 114 */     final Calendar finalLocalCalendar = localCalendar;
/* 115 */     new WithEntityOperationResult(source.getResponse(), Calendar.class) {};
/*     */   }
/*     */   
/*     */ 
/*     */   private void setCommonCalendarFields(Calendar target, ReportJobCalendar src)
/*     */   {
/* 121 */     target.setCalendarType(CalendarType.valueOf(src.getCalendarType()));
/* 122 */     target.setDescription(src.getDescription());
/* 123 */     target.setTimeZone(src.getTimeZone());
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncGet(final Callback<OperationResult<Calendar>, R> callback) {
/* 127 */     final JerseyRequest<ReportJobCalendar> request = JerseyRequest.buildRequest(this.sessionStorage, ReportJobCalendar.class, new String[] { "/jobs", "/calendars", this.calendarName });
/* 128 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 131 */         callback.execute(SingleCalendarOperationsAdapter.this.convertToLocalCalendarType(request.get()));
/*     */       }
/* 133 */     });
/* 134 */     ThreadPoolUtil.runAsynchronously(task);
/* 135 */     return task;
/*     */   }
/*     */   
/*     */   public OperationResult delete() {
/* 139 */     return JerseyRequest.buildRequest(this.sessionStorage, Object.class, new String[] { "/jobs", "/calendars", this.calendarName }).delete();
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncDelete(final Callback<OperationResult, R> callback) {
/* 143 */     final JerseyRequest request = JerseyRequest.buildRequest(this.sessionStorage, Object.class, new String[] { "/jobs", "/calendars", this.calendarName });
/* 144 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 147 */         callback.execute(request.delete());
/*     */       }
/* 149 */     });
/* 150 */     ThreadPoolUtil.runAsynchronously(task);
/* 151 */     return task;
/*     */   }
/*     */   
/*     */   public OperationResult<ReportJobCalendar> createNew(Calendar calendarDescriptor) {
/* 155 */     JerseyRequest<ReportJobCalendar> request = JerseyRequest.buildRequest(this.sessionStorage, ReportJobCalendar.class, new String[] { "/jobs", "/calendars", this.calendarName });
/* 156 */     request.addParams(this.params);
/* 157 */     return request.put(calendarDescriptor);
/*     */   }
/*     */   
/*     */   public <R> RequestExecution asyncCreateNew(final Calendar calendarDescriptor, final Callback<OperationResult<ReportJobCalendar>, R> callback) {
/* 161 */     final JerseyRequest<ReportJobCalendar> request = JerseyRequest.buildRequest(this.sessionStorage, ReportJobCalendar.class, new String[] { "/jobs", "/calendars", this.calendarName });
/* 162 */     request.addParams(this.params);
/* 163 */     RequestExecution task = new RequestExecution(new Runnable()
/*     */     {
/*     */       public void run() {
/* 166 */         callback.execute(request.put(calendarDescriptor));
/*     */       }
/* 168 */     });
/* 169 */     ThreadPoolUtil.runAsynchronously(task);
/* 170 */     return task;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\jobs\calendar\SingleCalendarOperationsAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */