/*     */ package com.jaspersoft.jasperserver.jaxrs.client.core;
/*     */ 
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler;
/*     */ import com.jaspersoft.jasperserver.jaxrs.client.filters.SessionOutputFilter;
/*     */ import java.security.SecureRandom;
/*     */ import java.util.Map;
/*     */ import javax.net.ssl.HostnameVerifier;
/*     */ import javax.net.ssl.SSLContext;
/*     */ import javax.net.ssl.SSLSession;
/*     */ import javax.ws.rs.client.Client;
/*     */ import javax.ws.rs.client.ClientBuilder;
/*     */ import javax.ws.rs.client.Entity;
/*     */ import javax.ws.rs.client.Invocation.Builder;
/*     */ import javax.ws.rs.client.WebTarget;
/*     */ import javax.ws.rs.core.Form;
/*     */ import javax.ws.rs.core.MediaType;
/*     */ import javax.ws.rs.core.NewCookie;
/*     */ import javax.ws.rs.core.Response;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SessionStorage
/*     */ {
/*     */   private RestClientConfiguration configuration;
/*     */   private AuthenticationCredentials credentials;
/*     */   private WebTarget rootTarget;
/*     */   private String sessionId;
/*     */   
/*     */   public SessionStorage(RestClientConfiguration configuration, AuthenticationCredentials credentials)
/*     */   {
/*  48 */     this.configuration = configuration;
/*  49 */     this.credentials = credentials;
/*  50 */     init();
/*     */   }
/*     */   
/*     */   private void initSSL(ClientBuilder clientBuilder) {
/*     */     try {
/*  55 */       SSLContext sslContext = SSLContext.getInstance("SSL");
/*  56 */       HostnameVerifier hostnameVerifier = new HostnameVerifier()
/*     */       {
/*     */         public boolean verify(String s, SSLSession sslSession) {
/*  59 */           return true;
/*     */         }
/*  61 */       };
/*  62 */       sslContext.init(null, this.configuration.getTrustManagers(), new SecureRandom());
/*     */       
/*  64 */       clientBuilder.sslContext(sslContext);
/*  65 */       clientBuilder.hostnameVerifier(hostnameVerifier);
/*     */     }
/*     */     catch (Exception e) {
/*  68 */       throw new RuntimeException("Unable inFolder init SSL context", e);
/*     */     }
/*     */   }
/*     */   
/*     */   private void init() {
/*  73 */     ClientBuilder clientBuilder = ClientBuilder.newBuilder();
/*     */     
/*  75 */     if (this.configuration.getJasperReportsServerUrl().startsWith("https")) {
/*  76 */       initSSL(clientBuilder);
/*     */     }
/*     */     
/*  79 */     Client client = clientBuilder.build();
/*  80 */     Integer connectionTimeout = this.configuration.getConnectionTimeout();
/*     */     
/*  82 */     if (connectionTimeout != null) {
/*  83 */       client.property("jersey.config.client.connectTimeout", connectionTimeout);
/*     */     }
/*     */     
/*  86 */     Integer readTimeout = this.configuration.getReadTimeout();
/*     */     
/*  88 */     if (readTimeout != null) {
/*  89 */       client.property("jersey.config.client.readTimeout", readTimeout);
/*     */     }
/*     */     
/*  92 */     this.rootTarget = client.target(this.configuration.getJasperReportsServerUrl());
/*  93 */     login();
/*  94 */     this.rootTarget.register(new SessionOutputFilter(this.sessionId));
/*     */   }
/*     */   
/*     */   private void login() {
/*  98 */     Form form = new Form();
/*  99 */     form.param("j_username", this.credentials.getUsername()).param("j_password", this.credentials.getPassword());
/*     */     
/* 101 */     WebTarget target = this.rootTarget.path("/rest/login");
/* 102 */     Response response = target.request().post(Entity.entity(form, MediaType.APPLICATION_FORM_URLENCODED_TYPE));
/*     */     
/* 104 */     if (response.getStatus() == 200) {
/* 105 */       this.sessionId = ((NewCookie)response.getCookies().get("JSESSIONID")).getValue();
/*     */     } else {
/* 107 */       new DefaultErrorHandler().handleError(response);
/*     */     }
/*     */   }
/*     */   
/*     */   public RestClientConfiguration getConfiguration() {
/* 112 */     return this.configuration;
/*     */   }
/*     */   
/*     */   public AuthenticationCredentials getCredentials() {
/* 116 */     return this.credentials;
/*     */   }
/*     */   
/*     */   public String getSessionId() {
/* 120 */     return this.sessionId;
/*     */   }
/*     */   
/*     */   public WebTarget getRootTarget() {
/* 124 */     return this.rootTarget;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\core\SessionStorage.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */