/*     */ package com.netapp.asup.avro;
/*     */ 
/*     */ import com.netapp.asup.common.AsupLogger;
/*     */ import com.netapp.asup.exception.AdapterException;
/*     */ import java.io.ByteArrayInputStream;
/*     */ import java.io.IOException;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collection;
/*     */ import java.util.HashSet;
/*     */ import java.util.Iterator;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Set;
/*     */ import org.apache.avro.Schema;
/*     */ import org.apache.avro.Schema.Field;
/*     */ import org.apache.avro.generic.GenericDatumReader;
/*     */ import org.apache.avro.generic.GenericRecord;
/*     */ import org.apache.avro.io.BinaryDecoder;
/*     */ import org.apache.avro.io.DecoderFactory;
/*     */ import org.apache.avro.util.Utf8;
/*     */ 
/*     */ public class AvroReader
/*     */ {
/*  24 */   private DecoderFactory factory = new DecoderFactory();
/*     */   
/*  26 */   private AsupLogger asupLogger = AsupLogger.getLogger(AvroReader.class);
/*     */   
/*     */   public static List<String> getSchemaAttributes(Schema schema) {
/*  29 */     List<String> list = new ArrayList();
/*  30 */     Schema instanceSchema = schema.getValueType();
/*  31 */     List<Schema.Field> fields = instanceSchema.getFields();
/*     */     
/*     */ 
/*  34 */     for (Schema.Field field : fields) {
/*  35 */       if ((field.name().equals("config")) || (field.name().equals("status"))) {
/*  36 */         Schema fieldSchema = field.schema();
/*  37 */         List<Schema.Field> attrs = fieldSchema.getFields();
/*  38 */         for (Schema.Field attr : attrs) {
/*  39 */           list.add(attr.name());
/*     */         }
/*     */       }
/*     */     }
/*  43 */     return list;
/*     */   }
/*     */   
/*     */   public BinaryDecoder getBinaryDecoder(byte[] bs) {
/*  47 */     ByteArrayInputStream in = new ByteArrayInputStream(bs);
/*  48 */     return this.factory.binaryDecoder(in, null);
/*     */   }
/*     */   
/*     */   public Map<Utf8, GenericRecord> getObjectValue(byte[] bs, Schema schema) throws AdapterException
/*     */   {
/*  53 */     GenericDatumReader<Map<Utf8, GenericRecord>> reader = new GenericDatumReader();
/*  54 */     reader.setSchema(schema);
/*     */     try {
/*  56 */       return (Map)reader.read(null, getBinaryDecoder(bs));
/*     */     } catch (IOException e) {
/*  58 */       throw new AdapterException(this.asupLogger, null, e.getMessage());
/*     */     }
/*     */   }
/*     */   
/*     */   public Utf8 getAttributeValue(Schema instanceSchema, GenericRecord instanceRecord, String attributeName)
/*     */   {
/*  64 */     List<Schema.Field> instanceFields = instanceSchema.getFields();
/*  65 */     Utf8 attributeValue = null;
/*  66 */     GenericRecord record = null;
/*  67 */     for (Schema.Field instanceField : instanceFields) {
/*  68 */       record = (GenericRecord)instanceRecord.get(instanceField.name());
/*  69 */       attributeValue = (Utf8)record.get(attributeName);
/*  70 */       if (attributeValue != null)
/*  71 */         return attributeValue;
/*     */     }
/*  73 */     return null;
/*     */   }
/*     */   
/*     */   public Utf8 getAttributeValue(byte[] value, Schema schema, String attributeName) throws AdapterException
/*     */   {
/*  78 */     Map<Utf8, GenericRecord> objectValue = getObjectValue(value, schema);
/*  79 */     return getAttributeValue(schema.getValueType(), (GenericRecord)objectValue.values().iterator().next(), attributeName.toLowerCase());
/*     */   }
/*     */   
/*     */ 
/*     */   public Set<Utf8> getAttributeValues(byte[] value, Schema schema, String attributeName)
/*     */     throws AdapterException
/*     */   {
/*  86 */     Set<Utf8> attrValues = new HashSet();
/*     */     
/*  88 */     String attrNameInlower = attributeName.toLowerCase();
/*  89 */     Map<Utf8, GenericRecord> objects = getObjectValue(value, schema);
/*  90 */     Schema valueTypeSchema = schema.getValueType();
/*     */     
/*  92 */     Utf8 attributeValue = null;
/*  93 */     for (GenericRecord object : objects.values()) {
/*  94 */       attributeValue = getAttributeValue(valueTypeSchema, object, attrNameInlower);
/*  95 */       if (null != attributeValue)
/*     */       {
/*  97 */         attrValues.add(attributeValue);
/*     */       }
/*     */     }
/* 100 */     return attrValues;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\avro\AvroReader.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */