/*     */ package com.netapp.asup.data.objects;
/*     */ 
/*     */ import com.netapp.asup.common.AsupLogger;
/*     */ import com.netapp.asup.metamodel.NodeObject;
/*     */ import com.netapp.asup.metamodel.NodeObject.RelationshipType;
/*     */ import com.netapp.asup.metamodel.Relation;
/*     */ import java.util.HashMap;
/*     */ import java.util.Iterator;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import java.util.Set;
/*     */ import org.apache.avro.Schema;
/*     */ import org.apache.avro.generic.GenericData.Array;
/*     */ import org.apache.avro.generic.GenericData.Record;
/*     */ import org.apache.avro.generic.GenericRecord;
/*     */ import org.apache.avro.util.Utf8;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class IndexBuilder
/*     */ {
/*     */   private static final String UNDERSCORE = "_";
/*     */   private static final String KEY_ATTRIBUTES = "key.attributes";
/*  25 */   private static final AsupLogger LOGGER = AsupLogger.getLogger(IndexBuilder.class);
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public static Map<Utf8, Map<Utf8, Map<Utf8, GenericData.Array<Utf8>>>> populateIndexesForParent(NodeObject parentNodeObject, String childObjectName, Map<Utf8, Map<Utf8, GenericRecord>> systemToGenericRecord, Map<Utf8, Map<Utf8, Map<Utf8, GenericData.Array<Utf8>>>> indexMap)
/*     */   {
/*  32 */     String keyName = null;
/*  33 */     String virtualObjectName = null;
/*     */     
/*  35 */     childObjectName = childObjectName.toLowerCase();
/*  36 */     String parentObjectName = parentNodeObject.getObjectName();
/*  37 */     String keyAttribute = parentNodeObject.getAttributeVal("key.attributes");
/*  38 */     Relation relation = parentNodeObject.getRelationMap(childObjectName);
/*     */     
/*  40 */     if (relation.getType() == NodeObject.RelationshipType.MULTI_RELATION) {
/*  41 */       for (Relation childRelation : relation.getRelations()) {
/*  42 */         keyName = childRelation.getKeyName();
/*  43 */         virtualObjectName = childRelation.getVirtualNodeName();
/*  44 */         populateIndexMap(keyName, virtualObjectName, parentObjectName, indexMap, systemToGenericRecord);
/*     */       }
/*     */     }
/*     */     else {
/*  48 */       keyName = relation.getKeyName();
/*  49 */       if (keyName == null) {
/*  50 */         keyName = keyAttribute;
/*     */       }
/*  52 */       populateIndexMap(keyName, null, parentObjectName, indexMap, systemToGenericRecord);
/*     */     }
/*     */     
/*     */ 
/*  56 */     return indexMap;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   private static void populateIndexMap(String keyName, String virtualObjectName, String parentObjectName, Map<Utf8, Map<Utf8, Map<Utf8, GenericData.Array<Utf8>>>> indexMap, Map<Utf8, Map<Utf8, GenericRecord>> systemToGenericRecord)
/*     */   {
/*  64 */     GenericData.Array<Utf8> childIds = null;
/*  65 */     Map<Utf8, GenericData.Array<Utf8>> systemMap = null;
/*  66 */     GenericData.Record record = null;
/*  67 */     Utf8 parentId = null;
/*  68 */     GenericData.Array<Utf8> localChildIds = null;
/*     */     
/*  70 */     Map<Utf8, Map<Utf8, GenericData.Array<Utf8>>> parentIdsMap = new HashMap();
/*     */     
/*  72 */     for (Iterator i$ = systemToGenericRecord.entrySet().iterator(); i$.hasNext();) { mapSysId = (Map.Entry)i$.next();
/*     */       
/*     */ 
/*  75 */       for (Map.Entry<Utf8, GenericRecord> mapInstance : ((Map)mapSysId.getValue()).entrySet())
/*     */       {
/*  77 */         parentId = null;
/*  78 */         record = (GenericData.Record)((GenericRecord)mapInstance.getValue()).get("config");
/*     */         
/*     */ 
/*  81 */         if (record != null)
/*     */         {
/*  83 */           parentId = (Utf8)record.get(keyName);
/*     */         }
/*  85 */         if ((parentId == null) && (parentObjectName.equalsIgnoreCase("SYSTEM")) && ("sys_id".equalsIgnoreCase(keyName)))
/*     */         {
/*  87 */           parentId = (Utf8)mapSysId.getKey();
/*     */         }
/*     */         
/*     */ 
/*  91 */         if (parentId == null) {
/*  92 */           LOGGER.info("-9999", "Unable to find parentId : " + keyName + ", Parent NodeName: " + parentObjectName + ", for child instance Key" + mapInstance.getKey() + " in system : " + mapSysId.getKey());
/*     */ 
/*     */ 
/*     */ 
/*     */         }
/*     */         else
/*     */         {
/*     */ 
/*     */ 
/*     */ 
/* 102 */           systemMap = (Map)parentIdsMap.get(parentId);
/*     */           
/* 104 */           if (systemMap == null) {
/* 105 */             systemMap = new HashMap();
/*     */           }
/*     */           
/* 108 */           childIds = (GenericData.Array)systemMap.get(mapSysId.getKey());
/*     */           
/* 110 */           if (childIds == null) {
/* 111 */             childIds = new GenericData.Array(1, ARMASchema.INDEX_MAP.getSchema().getValueType().getValueType().getValueType());
/*     */             
/*     */ 
/* 114 */             childIds.add(mapInstance.getKey());
/* 115 */             systemMap.put(mapSysId.getKey(), childIds);
/*     */ 
/*     */           }
/*     */           else
/*     */           {
/* 120 */             localChildIds = new GenericData.Array(childIds.size() + 1, ARMASchema.INDEX_MAP.getSchema().getValueType().getValueType().getValueType());
/*     */             
/*     */ 
/*     */ 
/* 124 */             for (Utf8 childId : childIds) {
/* 125 */               localChildIds.add(childId);
/*     */             }
/*     */             
/* 128 */             localChildIds.add(mapInstance.getKey());
/* 129 */             systemMap.put(mapSysId.getKey(), localChildIds);
/*     */           }
/* 131 */           if (virtualObjectName != null) {
/* 132 */             parentId = new Utf8(virtualObjectName + "_" + parentId.toString());
/*     */           }
/* 134 */           parentIdsMap.put(parentId, systemMap);
/*     */         } } }
/*     */     Map.Entry<Utf8, Map<Utf8, GenericRecord>> mapSysId;
/* 137 */     indexMap.put(new Utf8(parentObjectName), parentIdsMap);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\objects\IndexBuilder.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */