/*     */ package com.netapp.asupdata.client.ARMA.parsers;
/*     */ 
/*     */ import com.netapp.asup.client.arma.ARMAObject;
/*     */ import com.netapp.asup.client.arma.ARMAViewOnlyObject;
/*     */ import com.netapp.asup.common.AsupLogger;
/*     */ import com.netapp.asup.exception.ARMAIllegalArgumentException;
/*     */ import com.netapp.asup.metamodel.MetaModel;
/*     */ import com.netapp.asup.metamodel.NodeObject;
/*     */ import com.netapp.asupdata.client.ARMA.ARMAClientSession;
/*     */ import com.netapp.asupdata.client.ARMA.ARMAObjectImpl;
/*     */ import com.netapp.asupdata.client.ARMA.ARMAObjectStore;
/*     */ import com.netapp.asupdata.client.ARMA.NodeType;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Arrays;
/*     */ import java.util.Collection;
/*     */ 
/*     */ 
/*     */ 
/*     */ public class GraphParser
/*     */ {
/*  21 */   private static final AsupLogger LOGGER = AsupLogger.getLogger(GraphParser.class);
/*     */   
/*     */ 
/*  24 */   private static final GraphParser PARSER_INSTANCE = new GraphParser();
/*     */   
/*     */ 
/*     */   private static final String SYSTEM = "system";
/*     */   
/*     */ 
/*     */ 
/*     */   public static GraphParser getInstance()
/*     */   {
/*  33 */     return PARSER_INSTANCE;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Collection<? extends ARMAViewOnlyObject> getAllNodes(ARMAClientSession session, ARMAObject previousARMAObject, NodeObject nodeObject, boolean isReadOnly)
/*     */   {
/*  43 */     Collection<ARMAViewOnlyObject> allARMANodes = new ArrayList();
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  49 */     allARMANodes.addAll(getAllParents(session, previousARMAObject, nodeObject, isReadOnly));
/*     */     
/*     */ 
/*     */ 
/*  53 */     allARMANodes.addAll(getAllChilds(session, previousARMAObject, nodeObject, isReadOnly));
/*     */     
/*     */ 
/*  56 */     return allARMANodes;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Collection<? extends ARMAViewOnlyObject> getAllChilds(ARMAClientSession session, ARMAObject previousARMAObject, NodeObject nodeObject, boolean isReadOnly)
/*     */   {
/*  65 */     Collection<NodeObject> childNodes = nodeObject.getChildNodes();
/*  66 */     Collection<ARMAObject> childARMAObjects = new ArrayList();
/*  67 */     for (NodeObject childNode : childNodes) {
/*  68 */       if (isReadOnly) {
/*  69 */         childARMAObjects.add(new ARMAObjectImpl(session, childNode));
/*     */       }
/*     */       else {
/*  72 */         childARMAObjects.add(createObject(session, previousARMAObject, childNode, NodeType.CHILD));
/*     */       }
/*     */     }
/*     */     
/*  76 */     return childARMAObjects;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public Collection<? extends ARMAViewOnlyObject> getAllParents(ARMAClientSession session, ARMAObject previousARMAObject, NodeObject nodeObject, boolean readOnly)
/*     */   {
/*  86 */     Collection<ARMAObject> parentARMAObjects = new ArrayList();
/*     */     
/*  88 */     if ((!session.isClusterRoot()) && (nodeObject.getObjectName().equals("system"))) return parentARMAObjects;
/*  89 */     Collection<NodeObject> parentNodes = nodeObject.getParentNodes();
/*  90 */     for (NodeObject parentNode : parentNodes) {
/*  91 */       if (readOnly) {
/*  92 */         parentARMAObjects.add(new ARMAObjectImpl(session, parentNode));
/*     */       }
/*     */       else {
/*  95 */         parentARMAObjects.add(createObject(session, previousARMAObject, parentNode, NodeType.PARENT));
/*     */       }
/*     */     }
/*     */     
/*     */ 
/* 100 */     return parentARMAObjects;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public ARMAObject getParentNodeByName(ARMAClientSession session, ARMAObject previousARMAObject, NodeObject nodeObject, String objectName, boolean isReadOnly)
/*     */   {
/* 107 */     ARMAObject parentObj = null;
/*     */     
/* 109 */     if ((!session.isClusterRoot()) && (nodeObject.getObjectName().equals("system"))) return null;
/* 110 */     NodeObject parentObject = nodeObject.getParentByName(objectName);
/* 111 */     if (null != parentObject) {
/* 112 */       if (isReadOnly) {
/* 113 */         parentObj = new ARMAObjectImpl(session, parentObject);
/*     */       } else {
/* 115 */         parentObj = createObject(session, previousARMAObject, parentObject, NodeType.PARENT);
/*     */       }
/*     */     }
/*     */     else {
/* 119 */       LOGGER.warn(session.getRequestId(), "Not a valid parent:" + objectName + " for :" + previousARMAObject.getObjectName());
/*     */     }
/*     */     
/*     */ 
/* 123 */     return parentObj;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public ARMAObject getChildNodeByName(ARMAClientSession session, ARMAObject previousARMAObject, NodeObject nodeObject, String objectName, boolean isReadOnly)
/*     */   {
/* 130 */     ARMAObject childObj = null;
/* 131 */     NodeObject childObject = nodeObject.getChildByName(objectName);
/* 132 */     if (null != childObject) {
/* 133 */       if (isReadOnly) {
/* 134 */         childObj = new ARMAObjectImpl(session, childObject);
/*     */       } else {
/* 136 */         childObj = createObject(session, previousARMAObject, childObject, NodeType.CHILD);
/*     */       }
/*     */     }
/*     */     else {
/* 140 */       LOGGER.warn(session.getRequestId(), "Not a valid child:" + objectName + " for :" + previousARMAObject.getObjectName());
/*     */     }
/*     */     
/*     */ 
/* 144 */     return childObj;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public ARMAObject getFromAllByName(ARMAClientSession session, ARMAObject previousARMAObject, NodeObject nodeObject, String objectName, boolean isReadOnly)
/*     */   {
/* 151 */     ARMAObject armaObject = getParentNodeByName(session, previousARMAObject, nodeObject, objectName, isReadOnly);
/*     */     
/* 153 */     if (null == armaObject) {
/* 154 */       LOGGER.info(session.getRequestId(), "Node not present in parent :" + objectName + ".Searching in the childs");
/*     */       
/*     */ 
/*     */ 
/* 158 */       armaObject = getChildNodeByName(session, previousARMAObject, nodeObject, objectName, isReadOnly);
/*     */     }
/*     */     
/* 161 */     return armaObject;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public ARMAObject getParentNodeByNameFromStore(ARMAClientSession session, ARMAObjectImpl previousARMAObject, String objectName)
/*     */   {
/* 168 */     if ((!session.isClusterRoot()) && (previousARMAObject.getObjectName().equals("system"))) return null;
/* 169 */     NodeObject parentObject = previousARMAObject.getNodeObject().getParentByName(objectName);
/* 170 */     ARMAObject parentObj = null;
/*     */     
/* 172 */     if (null != parentObject) {
/* 173 */       parentObj = session.getObjectStore().getFromStore(objectName);
/*     */     }
/*     */     else {
/* 176 */       LOGGER.warn(session.getRequestId(), "Not a valid parent:" + objectName + " for :" + previousARMAObject.getObjectName());
/*     */     }
/*     */     
/*     */ 
/* 180 */     return parentObj;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public Collection<ARMAObject> getAllParentsFromStore(ARMAClientSession session, ARMAObjectImpl previousARMAObject)
/*     */   {
/* 188 */     Collection<ARMAObject> parentARMAObjects = new ArrayList();
/* 189 */     if ((!session.isClusterRoot()) && (previousARMAObject.getNodeObject().getObjectName().equals("system"))) return parentARMAObjects;
/* 190 */     Collection<NodeObject> parentObjects = previousARMAObject.getNodeObject().getParentNodes();
/*     */     
/*     */ 
/*     */ 
/* 194 */     String objectName = null;
/* 195 */     ARMAObject parentFromStore = null;
/* 196 */     for (NodeObject parentObject : parentObjects)
/*     */     {
/* 198 */       objectName = parentObject.getAttributeVal("nodeId");
/* 199 */       parentFromStore = session.getObjectStore().getFromStore(objectName);
/* 200 */       if (parentFromStore != null) {
/* 201 */         parentARMAObjects.add(parentFromStore);
/*     */       } else {
/* 203 */         LOGGER.warn(session.getRequestId(), "Parent " + objectName + " not present in the path for : " + previousARMAObject.getObjectName());
/*     */       }
/*     */     }
/* 206 */     return parentARMAObjects;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public ARMAObject getChildNodeByNameFromStore(ARMAClientSession session, ARMAObjectImpl previousARMAObject, String objectName)
/*     */   {
/* 218 */     NodeObject childObject = previousARMAObject.getNodeObject().getChildByName(objectName);
/* 219 */     ARMAObject childObj = null;
/*     */     
/* 221 */     if (null != childObject) {
/* 222 */       childObj = session.getObjectStore().getFromStore(objectName);
/*     */     } else {
/* 224 */       LOGGER.warn(session.getRequestId(), "Not a valid child:" + objectName + " for :" + previousARMAObject.getObjectName());
/*     */     }
/*     */     
/*     */ 
/* 228 */     return childObj;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public Collection<ARMAObject> getAllChildsFromStore(ARMAClientSession session, ARMAObjectImpl previousARMAObject)
/*     */   {
/* 236 */     Collection<NodeObject> childObjects = previousARMAObject.getNodeObject().getChildNodes();
/*     */     
/*     */ 
/* 239 */     Collection<ARMAObject> childARMAObjects = new ArrayList();
/*     */     
/* 241 */     String objectName = null;
/* 242 */     ARMAObject childFromStore = null;
/* 243 */     for (NodeObject childObject : childObjects) {
/* 244 */       objectName = childObject.getAttributeVal("nodeId");
/* 245 */       childFromStore = session.getObjectStore().getFromStore(objectName);
/*     */       
/* 247 */       if (childFromStore != null) {
/* 248 */         childARMAObjects.add(childFromStore);
/*     */       }
/*     */       else {
/* 251 */         LOGGER.warn(session.getRequestId(), "child " + objectName + " not present in the path for : " + previousARMAObject.getObjectName());
/*     */       }
/*     */     }
/*     */     
/* 255 */     return childARMAObjects;
/*     */   }
/*     */   
/*     */   private ARMAObjectImpl createObject(ARMAClientSession session, ARMAObject previousARMAObject, NodeObject nodeObject, NodeType nodeType)
/*     */   {
/* 260 */     String objectName = nodeObject.getName();
/* 261 */     ARMAObjectStore objectStore = session.getObjectStore();
/* 262 */     ARMAObjectImpl objectFromStore = (ARMAObjectImpl)objectStore.getFromStore(objectName);
/* 263 */     if (null == objectFromStore) {
/* 264 */       if (LOGGER.isDebugEnabled()) {
/* 265 */         LOGGER.debug(session.getRequestId(), "Node not present in store :" + objectName + ".Creating and adding to the store");
/*     */       }
/*     */       
/*     */ 
/* 269 */       objectFromStore = new ARMAObjectImpl(session, previousARMAObject, nodeObject, nodeType);
/*     */       
/* 271 */       objectStore.addToStore(objectName, objectFromStore);
/*     */     } else {
/* 273 */       if (LOGGER.isDebugEnabled()) {
/* 274 */         LOGGER.debug(session.getRequestId(), "Node present in store :" + objectName + ".Updating the path traversed");
/*     */       }
/*     */       
/*     */ 
/* 278 */       objectFromStore.updateMyPath(previousARMAObject, nodeType);
/*     */     }
/* 280 */     return objectFromStore;
/*     */   }
/*     */   
/*     */   public ARMAObject jumpToNode(ARMAClientSession session, String objectName)
/*     */     throws ARMAIllegalArgumentException
/*     */   {
/* 286 */     NodeObject nodeObj = session.getRootObject().getNodeObject().getMetaModel().getNode(objectName);
/* 287 */     if (nodeObj == null) {
/* 288 */       throw new ARMAIllegalArgumentException(LOGGER, "Invalid jump to node.No node by the name:" + objectName);
/*     */     }
/* 290 */     ARMAObjectImpl jumpedNode = new ARMAObjectImpl(session, null, nodeObj, NodeType.Root);
/*     */     
/*     */ 
/* 293 */     ARMAObjectStore objectStore = session.getObjectStore();
/* 294 */     objectStore.addToStore(objectName, jumpedNode);
/*     */     
/* 296 */     return jumpedNode;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public ARMAObject getLastNodeInPath(ARMAObjectImpl armaObjectImpl, String... connectedPath)
/*     */     throws ARMAIllegalArgumentException
/*     */   {
/* 304 */     validatePathConnectivity(armaObjectImpl, connectedPath);
/*     */     
/*     */ 
/* 307 */     String objectName = null;
/* 308 */     ARMAObject connectedNode = armaObjectImpl;
/*     */     
/* 310 */     for (int i = 0; i < connectedPath.length; i++) {
/* 311 */       objectName = connectedPath[i];
/* 312 */       connectedNode = connectedNode.getAll(objectName);
/*     */     }
/*     */     
/* 315 */     return connectedNode;
/*     */   }
/*     */   
/*     */   private void validatePathConnectivity(ARMAObject connectedNode, String[] connectedPath)
/*     */     throws ARMAIllegalArgumentException
/*     */   {
/* 321 */     ARMAObject currentnode = connectedNode;
/* 322 */     for (int i = 0; i < connectedPath.length; i++)
/*     */     {
/*     */ 
/*     */ 
/* 326 */       currentnode = (ARMAObject)currentnode.getViewOnlyAll(connectedPath[i]);
/* 327 */       if (null == currentnode) {
/* 328 */         throw new ARMAIllegalArgumentException(LOGGER, "The path is not connected path at this node:" + connectedPath[i] + " present at the position:" + (i + 1) + ".Completed path passed is:" + Arrays.asList(connectedPath));
/*     */       }
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asupdata\client\ARMA\parsers\GraphParser.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */