/*     */ package com.sun.xml.bind.v2.runtime;
/*     */ 
/*     */ import com.sun.xml.bind.v2.model.runtime.RuntimeArrayInfo;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Loader;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.Receiver;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.TagName;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext;
/*     */ import com.sun.xml.bind.v2.runtime.unmarshaller.UnmarshallingContext.State;
/*     */ import java.io.IOException;
/*     */ import java.lang.reflect.Array;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collection;
/*     */ import java.util.Collections;
/*     */ import java.util.List;
/*     */ import javax.xml.bind.helpers.ValidationEventImpl;
/*     */ import javax.xml.namespace.QName;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ final class ArrayBeanInfoImpl
/*     */   extends JaxBeanInfo
/*     */ {
/*     */   private final Class itemType;
/*     */   private final JaxBeanInfo itemBeanInfo;
/*     */   private final Loader loader;
/*     */   
/*     */   public ArrayBeanInfoImpl(JAXBContextImpl owner, RuntimeArrayInfo rai)
/*     */   {
/*  36 */     super(owner, rai, rai.getType(), rai.getTypeName(), false, true, false);
/*  37 */     this.itemType = this.jaxbType.getComponentType();
/*  38 */     this.itemBeanInfo = owner.getOrCreate(rai.getItemType());
/*     */     
/*  40 */     this.loader = new ArrayLoader(owner);
/*     */   }
/*     */   
/*     */   private final class ArrayLoader extends Loader implements Receiver { private final Loader itemLoader;
/*     */     
/*  45 */     public ArrayLoader(JAXBContextImpl owner) { super();
/*  46 */       this.itemLoader = ArrayBeanInfoImpl.this.itemBeanInfo.getLoader(owner, true);
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */     public void startElement(UnmarshallingContext.State state, TagName ea)
/*     */     {
/*  53 */       state.target = new ArrayList();
/*     */     }
/*     */     
/*     */     public void leaveElement(UnmarshallingContext.State state, TagName ea)
/*     */     {
/*  58 */       state.target = ArrayBeanInfoImpl.this.toArray((List)state.target);
/*     */     }
/*     */     
/*     */     public void childElement(UnmarshallingContext.State state, TagName ea) throws SAXException
/*     */     {
/*  63 */       if (ea.matches("", "item")) {
/*  64 */         state.loader = this.itemLoader;
/*  65 */         state.receiver = this;
/*     */       } else {
/*  67 */         super.childElement(state, ea);
/*     */       }
/*     */     }
/*     */     
/*     */     public Collection<QName> getExpectedChildElements()
/*     */     {
/*  73 */       return Collections.singleton(new QName("", "item"));
/*     */     }
/*     */     
/*     */     public void receive(UnmarshallingContext.State state, Object o) {
/*  77 */       ((List)state.target).add(o);
/*     */     }
/*     */   }
/*     */   
/*     */   protected Object toArray(List list) {
/*  82 */     int len = list.size();
/*  83 */     Object array = Array.newInstance(this.itemType, len);
/*  84 */     for (int i = 0; i < len; i++)
/*  85 */       Array.set(array, i, list.get(i));
/*  86 */     return array;
/*     */   }
/*     */   
/*     */   public void serializeBody(Object array, XMLSerializer target) throws SAXException, IOException, XMLStreamException {
/*  90 */     int len = Array.getLength(array);
/*  91 */     for (int i = 0; i < len; i++) {
/*  92 */       Object item = Array.get(array, i);
/*     */       
/*  94 */       target.startElement("", "item", null, null);
/*  95 */       if (item == null) {
/*  96 */         target.writeXsiNilTrue();
/*     */       } else {
/*  98 */         target.childAsXsiType(item, "arrayItem", this.itemBeanInfo);
/*     */       }
/* 100 */       target.endElement();
/*     */     }
/*     */   }
/*     */   
/*     */   public final String getElementNamespaceURI(Object array) {
/* 105 */     throw new UnsupportedOperationException();
/*     */   }
/*     */   
/*     */   public final String getElementLocalName(Object array) {
/* 109 */     throw new UnsupportedOperationException();
/*     */   }
/*     */   
/*     */   public final Object createInstance(UnmarshallingContext context)
/*     */   {
/* 114 */     return new ArrayList();
/*     */   }
/*     */   
/*     */   public final boolean reset(Object array, UnmarshallingContext context) {
/* 118 */     return false;
/*     */   }
/*     */   
/*     */   public final String getId(Object array, XMLSerializer target) {
/* 122 */     return null;
/*     */   }
/*     */   
/*     */   public final void serializeAttributes(Object array, XMLSerializer target) {}
/*     */   
/*     */   public final void serializeRoot(Object array, XMLSerializer target)
/*     */     throws SAXException, IOException, XMLStreamException
/*     */   {
/* 130 */     target.reportError(new ValidationEventImpl(1, Messages.UNABLE_TO_MARSHAL_NON_ELEMENT.format(new Object[] { array.getClass().getName() }), null, null));
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public final void serializeURIs(Object array, XMLSerializer target) {}
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public final Transducer getTransducer()
/*     */   {
/* 143 */     return null;
/*     */   }
/*     */   
/*     */   public final Loader getLoader(JAXBContextImpl context, boolean typeSubstitutionCapable)
/*     */   {
/* 148 */     return this.loader;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\ArrayBeanInfoImpl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */