/*     */ package com.sun.xml.bind.v2.runtime.unmarshaller;
/*     */ 
/*     */ import java.util.Iterator;
/*     */ import javax.xml.namespace.QName;
/*     */ import javax.xml.stream.Location;
/*     */ import javax.xml.stream.XMLEventReader;
/*     */ import javax.xml.stream.XMLStreamException;
/*     */ import javax.xml.stream.events.Attribute;
/*     */ import javax.xml.stream.events.Characters;
/*     */ import javax.xml.stream.events.EndElement;
/*     */ import javax.xml.stream.events.Namespace;
/*     */ import javax.xml.stream.events.StartElement;
/*     */ import javax.xml.stream.events.XMLEvent;
/*     */ import org.xml.sax.Attributes;
/*     */ import org.xml.sax.SAXException;
/*     */ import org.xml.sax.helpers.AttributesImpl;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ final class StAXEventConnector
/*     */   extends StAXConnector
/*     */ {
/*     */   private final XMLEventReader staxEventReader;
/*     */   private XMLEvent event;
/*  74 */   private final AttributesImpl attrs = new AttributesImpl();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  80 */   private final StringBuilder buffer = new StringBuilder();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private boolean seenText;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public StAXEventConnector(XMLEventReader staxCore, XmlVisitor visitor)
/*     */   {
/*  94 */     super(visitor);
/*  95 */     this.staxEventReader = staxCore;
/*     */   }
/*     */   
/*     */   public void bridge() throws XMLStreamException
/*     */   {
/*     */     try
/*     */     {
/* 102 */       int depth = 0;
/*     */       
/* 104 */       this.event = this.staxEventReader.peek();
/*     */       
/* 106 */       if ((!this.event.isStartDocument()) && (!this.event.isStartElement())) {
/* 107 */         throw new IllegalStateException();
/*     */       }
/*     */       do
/*     */       {
/* 111 */         this.event = this.staxEventReader.nextEvent();
/* 112 */       } while (!this.event.isStartElement());
/*     */       
/* 114 */       handleStartDocument(this.event.asStartElement().getNamespaceContext());
/*     */       
/*     */ 
/*     */ 
/*     */ 
/*     */       for (;;)
/*     */       {
/* 121 */         switch (this.event.getEventType()) {
/*     */         case 1: 
/* 123 */           handleStartElement(this.event.asStartElement());
/* 124 */           depth++;
/* 125 */           break;
/*     */         case 2: 
/* 127 */           depth--;
/* 128 */           handleEndElement(this.event.asEndElement());
/* 129 */           if (depth != 0) {
/*     */             break;
/*     */           }
/*     */           break;
/*     */         case 4: case 6: case 12: 
/* 134 */           handleCharacters(this.event.asCharacters());
/*     */         }
/*     */         
/*     */         
/*     */ 
/* 139 */         this.event = this.staxEventReader.nextEvent();
/*     */       }
/*     */       
/* 142 */       handleEndDocument();
/* 143 */       this.event = null;
/*     */     } catch (SAXException e) {
/* 145 */       throw new XMLStreamException(e);
/*     */     }
/*     */   }
/*     */   
/*     */ 
/* 150 */   protected Location getCurrentLocation() { return this.event.getLocation(); }
/*     */   
/*     */   protected String getCurrentQName() {
/*     */     QName qName;
/*     */     QName qName;
/* 155 */     if (this.event.isEndElement()) {
/* 156 */       qName = this.event.asEndElement().getName();
/*     */     } else
/* 158 */       qName = this.event.asStartElement().getName();
/* 159 */     return getQName(qName.getPrefix(), qName.getLocalPart());
/*     */   }
/*     */   
/*     */   private void handleCharacters(Characters event) throws SAXException, XMLStreamException
/*     */   {
/* 164 */     if (!this.predictor.expectText()) {
/* 165 */       return;
/*     */     }
/* 167 */     this.seenText = true;
/*     */     
/*     */     XMLEvent next;
/*     */     for (;;)
/*     */     {
/* 172 */       next = this.staxEventReader.peek();
/* 173 */       if (!isIgnorable(next))
/*     */         break;
/* 175 */       this.staxEventReader.nextEvent();
/*     */     }
/*     */     
/* 178 */     if (isTag(next))
/*     */     {
/* 180 */       this.visitor.text(event.getData());
/* 181 */       return;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/* 186 */     this.buffer.append(event.getData());
/*     */     
/*     */     for (;;)
/*     */     {
/* 190 */       next = this.staxEventReader.peek();
/* 191 */       if (isIgnorable(next))
/*     */       {
/* 193 */         this.staxEventReader.nextEvent();
/*     */       }
/*     */       else {
/* 196 */         if (isTag(next))
/*     */         {
/* 198 */           this.visitor.text(this.buffer);
/* 199 */           this.buffer.setLength(0);
/* 200 */           return;
/*     */         }
/*     */         
/* 203 */         this.buffer.append(next.asCharacters().getData());
/* 204 */         this.staxEventReader.nextEvent();
/*     */       }
/*     */     }
/*     */   }
/*     */   
/* 209 */   private boolean isTag(XMLEvent event) { int eventType = event.getEventType();
/* 210 */     return (eventType == 1) || (eventType == 2);
/*     */   }
/*     */   
/*     */   private boolean isIgnorable(XMLEvent event) {
/* 214 */     int eventType = event.getEventType();
/* 215 */     return (eventType == 5) || (eventType == 3);
/*     */   }
/*     */   
/*     */   private void handleEndElement(EndElement event) throws SAXException {
/* 219 */     if ((!this.seenText) && (this.predictor.expectText())) {
/* 220 */       this.visitor.text("");
/*     */     }
/*     */     
/*     */ 
/* 224 */     QName qName = event.getName();
/* 225 */     this.tagName.uri = fixNull(qName.getNamespaceURI());
/* 226 */     this.tagName.local = qName.getLocalPart();
/* 227 */     this.visitor.endElement(this.tagName);
/*     */     
/*     */ 
/* 230 */     for (Iterator<Namespace> i = event.getNamespaces(); i.hasNext();) {
/* 231 */       String prefix = fixNull(((Namespace)i.next()).getPrefix());
/* 232 */       this.visitor.endPrefixMapping(prefix);
/*     */     }
/*     */     
/* 235 */     this.seenText = false;
/*     */   }
/*     */   
/*     */   private void handleStartElement(StartElement event) throws SAXException
/*     */   {
/* 240 */     for (Iterator i = event.getNamespaces(); i.hasNext();) {
/* 241 */       Namespace ns = (Namespace)i.next();
/* 242 */       this.visitor.startPrefixMapping(fixNull(ns.getPrefix()), fixNull(ns.getNamespaceURI()));
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/* 248 */     QName qName = event.getName();
/* 249 */     this.tagName.uri = fixNull(qName.getNamespaceURI());
/* 250 */     String localName = qName.getLocalPart();
/* 251 */     this.tagName.uri = fixNull(qName.getNamespaceURI());
/* 252 */     this.tagName.local = localName;
/* 253 */     this.tagName.atts = getAttributes(event);
/* 254 */     this.visitor.startElement(this.tagName);
/*     */     
/* 256 */     this.seenText = false;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private Attributes getAttributes(StartElement event)
/*     */   {
/* 267 */     this.attrs.clear();
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 274 */     for (Iterator i = event.getAttributes(); i.hasNext();) {
/* 275 */       Attribute staxAttr = (Attribute)i.next();
/*     */       
/* 277 */       QName name = staxAttr.getName();
/* 278 */       String uri = fixNull(name.getNamespaceURI());
/* 279 */       String localName = name.getLocalPart();
/* 280 */       String prefix = name.getPrefix();
/*     */       String qName;
/* 282 */       String qName; if ((prefix == null) || (prefix.length() == 0)) {
/* 283 */         qName = localName;
/*     */       } else
/* 285 */         qName = prefix + ':' + localName;
/* 286 */       String type = staxAttr.getDTDType();
/* 287 */       String value = staxAttr.getValue();
/*     */       
/* 289 */       this.attrs.addAttribute(uri, localName, qName, type, value);
/*     */     }
/*     */     
/* 292 */     return this.attrs;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\unmarshaller\StAXEventConnector.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */