/*     */ package com.sun.xml.txw2;
/*     */ 
/*     */ import com.sun.xml.txw2.output.XmlSerializer;
/*     */ import java.util.HashMap;
/*     */ import java.util.Map;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class Document
/*     */ {
/*     */   private final XmlSerializer out;
/*  23 */   private boolean started = false;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  31 */   private Content current = null;
/*     */   
/*  33 */   private final Map<Class, DatatypeWriter> datatypeWriters = new HashMap();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*  38 */   private int iota = 1;
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*  43 */   private final NamespaceSupport inscopeNamespace = new NamespaceSupport();
/*     */   
/*     */ 
/*     */ 
/*     */   private NamespaceDecl activeNamespaces;
/*     */   
/*     */ 
/*     */ 
/*     */   Document(XmlSerializer out)
/*     */   {
/*  53 */     this.out = out;
/*  54 */     for (DatatypeWriter dw : DatatypeWriter.BUILDIN)
/*  55 */       this.datatypeWriters.put(dw.getType(), dw);
/*     */   }
/*     */   
/*     */   void flush() {
/*  59 */     this.out.flush();
/*     */   }
/*     */   
/*     */   void setFirstContent(Content c) {
/*  63 */     assert (this.current == null);
/*  64 */     this.current = new StartDocument();
/*  65 */     this.current.setNext(this, c);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public void addDatatypeWriter(DatatypeWriter<?> dw)
/*     */   {
/*  80 */     this.datatypeWriters.put(dw.getType(), dw);
/*     */   }
/*     */   
/*     */ 
/*     */   void run()
/*     */   {
/*     */     for (;;)
/*     */     {
/*  88 */       Content next = this.current.getNext();
/*  89 */       if ((next == null) || (!next.isReadyToCommit()))
/*  90 */         return;
/*  91 */       next.accept(this.visitor);
/*  92 */       next.written();
/*  93 */       this.current = next;
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   void writeValue(Object obj, NamespaceResolver nsResolver, StringBuilder buf)
/*     */   {
/* 104 */     if (obj == null) {
/* 105 */       throw new IllegalArgumentException("argument contains null");
/*     */     }
/* 107 */     if ((obj instanceof Object[])) {
/* 108 */       for (Object o : (Object[])obj)
/* 109 */         writeValue(o, nsResolver, buf);
/* 110 */       return;
/*     */     }
/* 112 */     if ((obj instanceof Iterable)) {
/* 113 */       for (Object o : (Iterable)obj)
/* 114 */         writeValue(o, nsResolver, buf);
/* 115 */       return;
/*     */     }
/*     */     
/* 118 */     if (buf.length() > 0) {
/* 119 */       buf.append(' ');
/*     */     }
/* 121 */     Class c = obj.getClass();
/* 122 */     while (c != null) {
/* 123 */       DatatypeWriter dw = (DatatypeWriter)this.datatypeWriters.get(c);
/* 124 */       if (dw != null) {
/* 125 */         dw.print(obj, nsResolver, buf);
/* 126 */         return;
/*     */       }
/* 128 */       c = c.getSuperclass();
/*     */     }
/*     */     
/*     */ 
/* 132 */     buf.append(obj);
/*     */   }
/*     */   
/*     */ 
/* 136 */   private final ContentVisitor visitor = new ContentVisitor()
/*     */   {
/*     */ 
/*     */     public void onStartDocument()
/*     */     {
/* 141 */       throw new IllegalStateException();
/*     */     }
/*     */     
/*     */     public void onEndDocument() {
/* 145 */       Document.this.out.endDocument();
/*     */     }
/*     */     
/*     */     public void onEndTag() {
/* 149 */       Document.this.out.endTag();
/* 150 */       Document.this.inscopeNamespace.popContext();
/* 151 */       Document.this.activeNamespaces = null;
/*     */     }
/*     */     
/*     */     public void onPcdata(StringBuilder buffer) {
/* 155 */       if (Document.this.activeNamespaces != null)
/* 156 */         buffer = Document.this.fixPrefix(buffer);
/* 157 */       Document.this.out.text(buffer);
/*     */     }
/*     */     
/*     */     public void onCdata(StringBuilder buffer) {
/* 161 */       if (Document.this.activeNamespaces != null)
/* 162 */         buffer = Document.this.fixPrefix(buffer);
/* 163 */       Document.this.out.cdata(buffer);
/*     */     }
/*     */     
/*     */     public void onComment(StringBuilder buffer) {
/* 167 */       if (Document.this.activeNamespaces != null)
/* 168 */         buffer = Document.this.fixPrefix(buffer);
/* 169 */       Document.this.out.comment(buffer);
/*     */     }
/*     */     
/*     */     public void onStartTag(String nsUri, String localName, Attribute attributes, NamespaceDecl namespaces) {
/* 173 */       assert (nsUri != null);
/* 174 */       assert (localName != null);
/*     */       
/* 176 */       Document.this.activeNamespaces = namespaces;
/*     */       
/* 178 */       if (!Document.this.started) {
/* 179 */         Document.this.started = true;
/* 180 */         Document.this.out.startDocument();
/*     */       }
/*     */       
/* 183 */       Document.this.inscopeNamespace.pushContext();
/*     */       
/*     */ 
/* 186 */       for (NamespaceDecl ns = namespaces; ns != null; ns = ns.next) {
/* 187 */         ns.declared = false;
/*     */         
/* 189 */         if (ns.prefix != null) {
/* 190 */           String uri = Document.this.inscopeNamespace.getURI(ns.prefix);
/* 191 */           if ((uri == null) || (!uri.equals(ns.uri)))
/*     */           {
/*     */ 
/*     */ 
/* 195 */             Document.this.inscopeNamespace.declarePrefix(ns.prefix, ns.uri);
/* 196 */             ns.declared = true;
/*     */           }
/*     */         }
/*     */       }
/*     */       
/*     */ 
/* 202 */       for (NamespaceDecl ns = namespaces; ns != null; ns = ns.next) {
/* 203 */         if (ns.prefix == null) {
/* 204 */           if (Document.this.inscopeNamespace.getURI("").equals(ns.uri)) {
/* 205 */             ns.prefix = "";
/*     */           } else {
/* 207 */             String p = Document.this.inscopeNamespace.getPrefix(ns.uri);
/* 208 */             if (p == null)
/*     */             {
/* 210 */               while (Document.this.inscopeNamespace.getURI(p = Document.this.newPrefix()) != null) {}
/*     */               
/* 212 */               ns.declared = true;
/* 213 */               Document.this.inscopeNamespace.declarePrefix(p, ns.uri);
/*     */             }
/* 215 */             ns.prefix = p;
/*     */           }
/*     */         }
/*     */       }
/*     */       
/*     */ 
/* 221 */       assert (namespaces.uri.equals(nsUri));
/* 222 */       assert (namespaces.prefix != null) : "a prefix must have been all allocated";
/* 223 */       Document.this.out.beginStartTag(nsUri, localName, namespaces.prefix);
/*     */       
/*     */ 
/* 226 */       for (NamespaceDecl ns = namespaces; ns != null; ns = ns.next) {
/* 227 */         if (ns.declared) {
/* 228 */           Document.this.out.writeXmlns(ns.prefix, ns.uri);
/*     */         }
/*     */       }
/*     */       
/* 232 */       for (Attribute a = attributes; a != null; a = a.next) { String prefix;
/*     */         String prefix;
/* 234 */         if (a.nsUri.length() == 0) prefix = ""; else
/* 235 */           prefix = Document.this.inscopeNamespace.getPrefix(a.nsUri);
/* 236 */         Document.this.out.writeAttribute(a.nsUri, a.localName, prefix, Document.this.fixPrefix(a.value));
/*     */       }
/*     */       
/* 239 */       Document.this.out.endStartTag(nsUri, localName, namespaces.prefix);
/*     */     }
/*     */   };
/*     */   
/*     */ 
/*     */ 
/*     */ 
/* 246 */   private final StringBuilder prefixSeed = new StringBuilder("ns");
/*     */   
/* 248 */   private int prefixIota = 0;
/*     */   
/*     */   static final char MAGIC = '\000';
/*     */   
/*     */   private String newPrefix()
/*     */   {
/* 254 */     this.prefixSeed.setLength(2);
/* 255 */     this.prefixSeed.append(++this.prefixIota);
/* 256 */     return this.prefixSeed.toString();
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   private StringBuilder fixPrefix(StringBuilder buf)
/*     */   {
/* 267 */     assert (this.activeNamespaces != null);
/*     */     
/*     */ 
/* 270 */     int len = buf.length();
/* 271 */     for (int i = 0; i < len; i++) {
/* 272 */       if (buf.charAt(i) == 0) {
/*     */         break;
/*     */       }
/*     */     }
/* 276 */     if (i == len) {
/* 277 */       return buf;
/*     */     }
/* 279 */     for (; i < len; 
/*     */         
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 299 */         goto 227)
/*     */     {
/* 280 */       char uriIdx = buf.charAt(i + 1);
/* 281 */       NamespaceDecl ns = this.activeNamespaces;
/* 282 */       while ((ns != null) && (ns.uniqueId != uriIdx))
/* 283 */         ns = ns.next;
/* 284 */       if (ns == null) {
/* 285 */         throw new IllegalStateException("Unexpected use of prefixes " + buf);
/*     */       }
/* 287 */       int length = 2;
/* 288 */       String prefix = ns.prefix;
/* 289 */       if (prefix.length() == 0) {
/* 290 */         if ((buf.length() <= i + 2) || (buf.charAt(i + 2) != ':'))
/* 291 */           throw new IllegalStateException("Unexpected use of prefixes " + buf);
/* 292 */         length = 3;
/*     */       }
/*     */       
/* 295 */       buf.replace(i, i + length, prefix);
/* 296 */       len += prefix.length() - length;
/*     */       
/* 298 */       if ((i < len) && (buf.charAt(i) != 0)) {
/* 299 */         i++;
/*     */       }
/*     */     }
/* 302 */     return buf;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   char assignNewId()
/*     */   {
/* 311 */     return (char)this.iota++;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\txw2\Document.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */