/*     */ package net.rubyeye.xmemcached.impl;
/*     */ 
/*     */ import com.google.code.yanf4j.core.Session;
/*     */ import java.net.InetSocketAddress;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collection;
/*     */ import java.util.List;
/*     */ import java.util.Random;
/*     */ import java.util.SortedMap;
/*     */ import java.util.TreeMap;
/*     */ import net.rubyeye.xmemcached.HashAlgorithm;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class LibmemcachedMemcachedSessionLocator
/*     */   extends AbstractMemcachedSessionLocator
/*     */ {
/*     */   static final int DEFAULT_NUM_REPS = 100;
/*  37 */   private volatile transient TreeMap<Long, List<Session>> ketamaSessions = new TreeMap();
/*     */   private volatile int maxTries;
/*  39 */   private int numReps = 100;
/*  40 */   private final Random random = new Random();
/*  41 */   private HashAlgorithm hashAlgorithm = HashAlgorithm.ONE_AT_A_TIME;
/*     */   
/*     */ 
/*     */   public LibmemcachedMemcachedSessionLocator() {}
/*     */   
/*     */ 
/*     */   public LibmemcachedMemcachedSessionLocator(int numReps, HashAlgorithm hashAlgorithm)
/*     */   {
/*  49 */     this.numReps = numReps;
/*  50 */     this.hashAlgorithm = hashAlgorithm;
/*     */   }
/*     */   
/*     */   private final void buildMap(Collection<Session> list, HashAlgorithm alg) {
/*  54 */     TreeMap<Long, List<Session>> sessionMap = new TreeMap();
/*     */     
/*  56 */     for (Session session : list) {
/*  57 */       String sockStr = null;
/*  58 */       if (session.getRemoteSocketAddress().getPort() != 11211) {
/*  59 */         sockStr = session.getRemoteSocketAddress().getHostName() + ":" + session.getRemoteSocketAddress().getPort();
/*     */       }
/*     */       else {
/*  62 */         sockStr = session.getRemoteSocketAddress().getHostName();
/*     */       }
/*  64 */       for (int i = 0; i < this.numReps; i++) {
/*  65 */         long key = this.hashAlgorithm.hash(sockStr + "-" + i);
/*  66 */         getSessionList(sessionMap, key).add(session);
/*     */       }
/*     */     }
/*  69 */     this.ketamaSessions = sessionMap;
/*  70 */     this.maxTries = list.size();
/*     */   }
/*     */   
/*     */   private List<Session> getSessionList(TreeMap<Long, List<Session>> sessionMap, long k)
/*     */   {
/*  75 */     List<Session> sessionList = (List)sessionMap.get(Long.valueOf(k));
/*  76 */     if (sessionList == null) {
/*  77 */       sessionList = new ArrayList();
/*  78 */       sessionMap.put(Long.valueOf(k), sessionList);
/*     */     }
/*  80 */     return sessionList;
/*     */   }
/*     */   
/*     */   public final Session getSessionByKey(String key) {
/*  84 */     if ((this.ketamaSessions == null) || (this.ketamaSessions.size() == 0)) {
/*  85 */       return null;
/*     */     }
/*  87 */     long hash = this.hashAlgorithm.hash(key);
/*  88 */     Session rv = getSessionByHash(hash);
/*  89 */     int tries = 0;
/*     */     
/*  91 */     while ((!this.failureMode) && ((rv == null) || (rv.isClosed())) && (tries++ < this.maxTries)) {
/*  92 */       hash = nextHash(hash, key, tries);
/*  93 */       rv = getSessionByHash(hash);
/*     */     }
/*  95 */     return rv;
/*     */   }
/*     */   
/*     */   public final Session getSessionByHash(long hash) {
/*  99 */     TreeMap<Long, List<Session>> sessionMap = this.ketamaSessions;
/* 100 */     if (sessionMap.size() == 0) {
/* 101 */       return null;
/*     */     }
/* 103 */     Long resultHash = Long.valueOf(hash);
/* 104 */     if (!sessionMap.containsKey(Long.valueOf(hash)))
/*     */     {
/*     */ 
/* 107 */       SortedMap<Long, List<Session>> tailMap = sessionMap.tailMap(Long.valueOf(hash));
/* 108 */       if (tailMap.isEmpty()) {
/* 109 */         resultHash = (Long)sessionMap.firstKey();
/*     */       } else {
/* 111 */         resultHash = (Long)tailMap.firstKey();
/*     */       }
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 121 */     List<Session> sessionList = (List)sessionMap.get(resultHash);
/* 122 */     if ((sessionList == null) || (sessionList.size() == 0)) {
/* 123 */       return null;
/*     */     }
/* 125 */     int size = sessionList.size();
/* 126 */     return (Session)sessionList.get(this.random.nextInt(size));
/*     */   }
/*     */   
/*     */   public final long nextHash(long hashVal, String key, int tries) {
/* 130 */     long tmpKey = this.hashAlgorithm.hash(tries + key);
/* 131 */     hashVal += (int)(tmpKey ^ tmpKey >>> 32);
/* 132 */     hashVal &= 0xFFFFFFFF;
/* 133 */     return hashVal;
/*     */   }
/*     */   
/*     */   public final void updateSessions(Collection<Session> list) {
/* 137 */     buildMap(list, null);
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\net\rubyeye\xmemcached\impl\LibmemcachedMemcachedSessionLocator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */