package org.codehaus.janino;

public class Visitor
{
  public static abstract interface LvalueVisitor
  {
    public abstract void visitAmbiguousName(Java.AmbiguousName paramAmbiguousName);
    
    public abstract void visitArrayAccessExpression(Java.ArrayAccessExpression paramArrayAccessExpression);
    
    public abstract void visitFieldAccess(Java.FieldAccess paramFieldAccess);
    
    public abstract void visitFieldAccessExpression(Java.FieldAccessExpression paramFieldAccessExpression);
    
    public abstract void visitSuperclassFieldAccessExpression(Java.SuperclassFieldAccessExpression paramSuperclassFieldAccessExpression);
    
    public abstract void visitLocalVariableAccess(Java.LocalVariableAccess paramLocalVariableAccess);
    
    public abstract void visitParenthesizedExpression(Java.ParenthesizedExpression paramParenthesizedExpression);
  }
  
  public static abstract interface RvalueVisitor
    extends Visitor.LvalueVisitor
  {
    public abstract void visitArrayLength(Java.ArrayLength paramArrayLength);
    
    public abstract void visitAssignment(Java.Assignment paramAssignment);
    
    public abstract void visitUnaryOperation(Java.UnaryOperation paramUnaryOperation);
    
    public abstract void visitBinaryOperation(Java.BinaryOperation paramBinaryOperation);
    
    public abstract void visitCast(Java.Cast paramCast);
    
    public abstract void visitClassLiteral(Java.ClassLiteral paramClassLiteral);
    
    public abstract void visitConditionalExpression(Java.ConditionalExpression paramConditionalExpression);
    
    public abstract void visitCrement(Java.Crement paramCrement);
    
    public abstract void visitInstanceof(Java.Instanceof paramInstanceof);
    
    public abstract void visitMethodInvocation(Java.MethodInvocation paramMethodInvocation);
    
    public abstract void visitSuperclassMethodInvocation(Java.SuperclassMethodInvocation paramSuperclassMethodInvocation);
    
    public abstract void visitLiteral(Java.Literal paramLiteral);
    
    public abstract void visitNewAnonymousClassInstance(Java.NewAnonymousClassInstance paramNewAnonymousClassInstance);
    
    public abstract void visitNewArray(Java.NewArray paramNewArray);
    
    public abstract void visitNewInitializedArray(Java.NewInitializedArray paramNewInitializedArray);
    
    public abstract void visitNewClassInstance(Java.NewClassInstance paramNewClassInstance);
    
    public abstract void visitParameterAccess(Java.ParameterAccess paramParameterAccess);
    
    public abstract void visitQualifiedThisReference(Java.QualifiedThisReference paramQualifiedThisReference);
    
    public abstract void visitThisReference(Java.ThisReference paramThisReference);
  }
  
  public static abstract interface TypeVisitor
  {
    public abstract void visitArrayType(Java.ArrayType paramArrayType);
    
    public abstract void visitBasicType(Java.BasicType paramBasicType);
    
    public abstract void visitReferenceType(Java.ReferenceType paramReferenceType);
    
    public abstract void visitRvalueMemberType(Java.RvalueMemberType paramRvalueMemberType);
    
    public abstract void visitSimpleType(Java.SimpleType paramSimpleType);
  }
  
  public static abstract interface AtomVisitor
    extends Visitor.RvalueVisitor, Visitor.TypeVisitor
  {
    public abstract void visitPackage(Java.Package paramPackage);
  }
  
  public static abstract interface BlockStatementVisitor
  {
    public abstract void visitInitializer(Java.Initializer paramInitializer);
    
    public abstract void visitFieldDeclaration(Java.FieldDeclaration paramFieldDeclaration);
    
    public abstract void visitLabeledStatement(Java.LabeledStatement paramLabeledStatement);
    
    public abstract void visitBlock(Java.Block paramBlock);
    
    public abstract void visitExpressionStatement(Java.ExpressionStatement paramExpressionStatement);
    
    public abstract void visitIfStatement(Java.IfStatement paramIfStatement);
    
    public abstract void visitForStatement(Java.ForStatement paramForStatement);
    
    public abstract void visitWhileStatement(Java.WhileStatement paramWhileStatement);
    
    public abstract void visitTryStatement(Java.TryStatement paramTryStatement);
    
    public abstract void visitSwitchStatement(Java.SwitchStatement paramSwitchStatement);
    
    public abstract void visitSynchronizedStatement(Java.SynchronizedStatement paramSynchronizedStatement);
    
    public abstract void visitDoStatement(Java.DoStatement paramDoStatement);
    
    public abstract void visitLocalVariableDeclarationStatement(Java.LocalVariableDeclarationStatement paramLocalVariableDeclarationStatement);
    
    public abstract void visitReturnStatement(Java.ReturnStatement paramReturnStatement);
    
    public abstract void visitThrowStatement(Java.ThrowStatement paramThrowStatement);
    
    public abstract void visitBreakStatement(Java.BreakStatement paramBreakStatement);
    
    public abstract void visitContinueStatement(Java.ContinueStatement paramContinueStatement);
    
    public abstract void visitEmptyStatement(Java.EmptyStatement paramEmptyStatement);
    
    public abstract void visitLocalClassDeclarationStatement(Java.LocalClassDeclarationStatement paramLocalClassDeclarationStatement);
    
    public abstract void visitAlternateConstructorInvocation(Java.AlternateConstructorInvocation paramAlternateConstructorInvocation);
    
    public abstract void visitSuperConstructorInvocation(Java.SuperConstructorInvocation paramSuperConstructorInvocation);
  }
  
  public static abstract interface TypeBodyDeclarationVisitor
  {
    public abstract void visitMemberInterfaceDeclaration(Java.MemberInterfaceDeclaration paramMemberInterfaceDeclaration);
    
    public abstract void visitMemberClassDeclaration(Java.MemberClassDeclaration paramMemberClassDeclaration);
    
    public abstract void visitConstructorDeclarator(Java.ConstructorDeclarator paramConstructorDeclarator);
    
    public abstract void visitInitializer(Java.Initializer paramInitializer);
    
    public abstract void visitMethodDeclarator(Java.MethodDeclarator paramMethodDeclarator);
    
    public abstract void visitFieldDeclaration(Java.FieldDeclaration paramFieldDeclaration);
  }
  
  public static abstract interface TypeDeclarationVisitor
  {
    public abstract void visitAnonymousClassDeclaration(Java.AnonymousClassDeclaration paramAnonymousClassDeclaration);
    
    public abstract void visitLocalClassDeclaration(Java.LocalClassDeclaration paramLocalClassDeclaration);
    
    public abstract void visitPackageMemberClassDeclaration(Java.PackageMemberClassDeclaration paramPackageMemberClassDeclaration);
    
    public abstract void visitMemberInterfaceDeclaration(Java.MemberInterfaceDeclaration paramMemberInterfaceDeclaration);
    
    public abstract void visitPackageMemberInterfaceDeclaration(Java.PackageMemberInterfaceDeclaration paramPackageMemberInterfaceDeclaration);
    
    public abstract void visitMemberClassDeclaration(Java.MemberClassDeclaration paramMemberClassDeclaration);
  }
  
  public static abstract interface ImportVisitor
  {
    public abstract void visitSingleTypeImportDeclaration(Java.CompilationUnit.SingleTypeImportDeclaration paramSingleTypeImportDeclaration);
    
    public abstract void visitTypeImportOnDemandDeclaration(Java.CompilationUnit.TypeImportOnDemandDeclaration paramTypeImportOnDemandDeclaration);
    
    public abstract void visitSingleStaticImportDeclaration(Java.CompilationUnit.SingleStaticImportDeclaration paramSingleStaticImportDeclaration);
    
    public abstract void visitStaticImportOnDemandDeclaration(Java.CompilationUnit.StaticImportOnDemandDeclaration paramStaticImportOnDemandDeclaration);
  }
  
  public static abstract interface ComprehensiveVisitor
    extends Visitor.ImportVisitor, Visitor.TypeDeclarationVisitor, Visitor.TypeBodyDeclarationVisitor, Visitor.BlockStatementVisitor, Visitor.AtomVisitor
  {}
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\Visitor.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */