/*    */ package com.jaspersoft.jasperserver.api.common.domain.jaxb;
/*    */ 
/*    */ import java.util.Arrays;
/*    */ import java.util.List;
/*    */ import javax.xml.bind.annotation.adapters.XmlAdapter;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public abstract class AbstractEnumXmlAdapter<PropertyType>
/*    */   extends XmlAdapter<String, PropertyType>
/*    */ {
/*    */   public PropertyType unmarshal(String v)
/*    */     throws Exception
/*    */   {
/* 39 */     PropertyType result = null;
/* 40 */     if ((v != null) && (!"".equals(v)))
/* 41 */       for (NamedPropertyHolder<PropertyType> currentConstant : getEnumConstantsList())
/* 42 */         if (currentConstant.name().equals(v)) {
/* 43 */           result = currentConstant.getProperty();
/* 44 */           break;
/*    */         }
/* 46 */     return result;
/*    */   }
/*    */   
/*    */   public String marshal(PropertyType v) throws Exception
/*    */   {
/* 51 */     String result = null;
/* 52 */     for (NamedPropertyHolder<PropertyType> currentConstant : getEnumConstantsList()) {
/* 53 */       if (currentConstant.getProperty().equals(v)) {
/* 54 */         result = currentConstant.name();
/* 55 */         break;
/*    */       }
/*    */     }
/* 58 */     return result;
/*    */   }
/*    */   
/*    */   protected List<NamedPropertyHolder<PropertyType>> getEnumConstantsList() {
/* 62 */     return Arrays.asList(getEnumConstantsArray());
/*    */   }
/*    */   
/*    */   protected abstract NamedPropertyHolder<PropertyType>[] getEnumConstantsArray();
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-api-common-6.0.jar!\com\jaspersoft\jasperserver\api\common\domain\jaxb\AbstractEnumXmlAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */