package com.jaspersoft.jasperserver.api.engine.scheduling.service;

import com.jaspersoft.jasperserver.api.JSException;
import com.jaspersoft.jasperserver.api.JasperServerAPI;
import com.jaspersoft.jasperserver.api.common.domain.ExecutionContext;
import com.jaspersoft.jasperserver.api.common.domain.ValidationErrors;
import com.jaspersoft.jasperserver.api.engine.scheduling.domain.ReportJob;
import com.jaspersoft.jasperserver.api.engine.scheduling.domain.ReportJobIdHolder;
import com.jaspersoft.jasperserver.api.engine.scheduling.domain.ReportJobRuntimeInformation;
import java.util.List;
import org.quartz.Calendar;

@JasperServerAPI
public abstract interface ReportJobsScheduler
{
  public abstract void scheduleJob(ExecutionContext paramExecutionContext, ReportJob paramReportJob);
  
  public abstract void rescheduleJob(ExecutionContext paramExecutionContext, ReportJob paramReportJob);
  
  public abstract void removeScheduledJob(ExecutionContext paramExecutionContext, long paramLong);
  
  public abstract void addReportSchedulerListener(ReportSchedulerListener paramReportSchedulerListener);
  
  public abstract void removeReportSchedulerListener(ReportSchedulerListener paramReportSchedulerListener);
  
  public abstract ReportJobRuntimeInformation[] getJobsRuntimeInformation(ExecutionContext paramExecutionContext, long[] paramArrayOfLong);
  
  public abstract void validate(ReportJob paramReportJob, ValidationErrors paramValidationErrors);
  
  public abstract void addCalendar(String paramString, Calendar paramCalendar, boolean paramBoolean1, boolean paramBoolean2)
    throws JSException;
  
  public abstract boolean deleteCalendar(String paramString)
    throws JSException;
  
  public abstract Calendar getCalendar(String paramString)
    throws JSException;
  
  public abstract List<String> getCalendarNames()
    throws JSException;
  
  public abstract void pause(List<ReportJob> paramList, boolean paramBoolean);
  
  public abstract void resume(List<ReportJob> paramList, boolean paramBoolean);
  
  public abstract void pauseById(List<ReportJobIdHolder> paramList, boolean paramBoolean);
  
  public abstract void resumeById(List<ReportJobIdHolder> paramList, boolean paramBoolean);
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jasperserver-api-engine-6.0.jar!\com\jaspersoft\jasperserver\api\engine\scheduling\service\ReportJobsScheduler.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */