/*    */ package com.jaspersoft.jasperserver.jaxrs.client.apiadapters.resources;
/*    */ 
/*    */ import com.jaspersoft.jasperserver.dto.resources.ClientResourceListWrapper;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.apiadapters.AbstractAdapter;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.Callback;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.JerseyRequest;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.RequestExecution;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.SessionStorage;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.ThreadPoolUtil;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.exceptions.handling.DefaultErrorHandler;
/*    */ import com.jaspersoft.jasperserver.jaxrs.client.core.operationresult.OperationResult;
/*    */ import javax.ws.rs.core.MultivaluedHashMap;
/*    */ import javax.ws.rs.core.MultivaluedMap;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class BatchResourcesAdapter
/*    */   extends AbstractAdapter
/*    */ {
/*    */   private MultivaluedMap<String, String> params;
/*    */   
/*    */   public BatchResourcesAdapter(SessionStorage sessionStorage)
/*    */   {
/* 38 */     super(sessionStorage);
/* 39 */     this.params = new MultivaluedHashMap();
/*    */   }
/*    */   
/*    */   public BatchResourcesAdapter parameter(ResourceSearchParameter param, String value) {
/* 43 */     this.params.add(param.getName(), value);
/* 44 */     return this;
/*    */   }
/*    */   
/*    */   public OperationResult<ClientResourceListWrapper> search() {
/* 48 */     return getBuilder(ClientResourceListWrapper.class).get();
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncSearch(final Callback<OperationResult<ClientResourceListWrapper>, R> callback) {
/* 52 */     final JerseyRequest<ClientResourceListWrapper> request = getBuilder(ClientResourceListWrapper.class);
/*    */     
/* 54 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 57 */         callback.execute(request.get());
/*    */       }
/*    */       
/* 60 */     });
/* 61 */     ThreadPoolUtil.runAsynchronously(task);
/* 62 */     return task;
/*    */   }
/*    */   
/*    */   public OperationResult delete() {
/* 66 */     return getBuilder(Object.class).delete();
/*    */   }
/*    */   
/*    */   public <R> RequestExecution asyncDelete(final Callback<OperationResult, R> callback) {
/* 70 */     final JerseyRequest request = getBuilder(Object.class);
/*    */     
/* 72 */     RequestExecution task = new RequestExecution(new Runnable()
/*    */     {
/*    */       public void run() {
/* 75 */         callback.execute(request.delete());
/*    */       }
/*    */       
/* 78 */     });
/* 79 */     ThreadPoolUtil.runAsynchronously(task);
/* 80 */     return task;
/*    */   }
/*    */   
/*    */   private <T> JerseyRequest<T> getBuilder(Class<T> responseClass) {
/* 84 */     JerseyRequest<T> request = JerseyRequest.buildRequest(this.sessionStorage, responseClass, new String[] { "/resources" }, new DefaultErrorHandler());
/* 85 */     request.addParams(this.params);
/* 86 */     return request;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\jrs-rest-java-client-6.0.3-ALPHA.jar!\com\jaspersoft\jasperserver\jaxrs\client\apiadapters\resources\BatchResourcesAdapter.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */