/*    */ package com.sun.xml.bind.v2.runtime;
/*    */ 
/*    */ import com.sun.xml.bind.api.AccessorException;
/*    */ import java.io.IOException;
/*    */ import javax.activation.MimeType;
/*    */ import javax.xml.stream.XMLStreamException;
/*    */ import org.xml.sax.SAXException;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public final class MimeTypedTransducer<V>
/*    */   extends FilterTransducer<V>
/*    */ {
/*    */   private final MimeType expectedMimeType;
/*    */   
/*    */   public MimeTypedTransducer(Transducer<V> core, MimeType expectedMimeType)
/*    */   {
/* 27 */     super(core);
/* 28 */     this.expectedMimeType = expectedMimeType;
/*    */   }
/*    */   
/*    */   public CharSequence print(V o) throws AccessorException
/*    */   {
/* 33 */     XMLSerializer w = XMLSerializer.getInstance();
/* 34 */     MimeType old = w.setExpectedMimeType(this.expectedMimeType);
/*    */     try {
/* 36 */       return this.core.print(o);
/*    */     } finally {
/* 38 */       w.setExpectedMimeType(old);
/*    */     }
/*    */   }
/*    */   
/*    */   public void writeText(XMLSerializer w, V o, String fieldName) throws IOException, SAXException, XMLStreamException, AccessorException
/*    */   {
/* 44 */     MimeType old = w.setExpectedMimeType(this.expectedMimeType);
/*    */     try {
/* 46 */       this.core.writeText(w, o, fieldName);
/*    */     } finally {
/* 48 */       w.setExpectedMimeType(old);
/*    */     }
/*    */   }
/*    */   
/*    */   public void writeLeafElement(XMLSerializer w, Name tagName, V o, String fieldName) throws IOException, SAXException, XMLStreamException, AccessorException
/*    */   {
/* 54 */     MimeType old = w.setExpectedMimeType(this.expectedMimeType);
/*    */     try {
/* 56 */       this.core.writeLeafElement(w, tagName, o, fieldName);
/*    */     } finally {
/* 58 */       w.setExpectedMimeType(old);
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\MimeTypedTransducer.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */