/*     */ package com.sun.xml.bind.v2.runtime;
/*     */ 
/*     */ import com.sun.xml.bind.util.ValidationEventLocatorExImpl;
/*     */ import java.util.Collections;
/*     */ import java.util.HashMap;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import javax.xml.bind.ValidationEvent;
/*     */ import javax.xml.bind.annotation.adapters.XmlAdapter;
/*     */ import javax.xml.bind.helpers.PrintConversionEventImpl;
/*     */ import javax.xml.bind.helpers.ValidationEventImpl;
/*     */ import javax.xml.bind.helpers.ValidationEventLocatorImpl;
/*     */ import org.xml.sax.SAXException;
/*     */ 
/*     */ 
/*     */ 
/*     */ public class RuntimeUtil
/*     */ {
/*     */   public static final Map<Class, Class> boxToPrimitive;
/*     */   public static final Map<Class, Class> primitiveToBox;
/*     */   
/*     */   public static final class ToStringAdapter
/*     */     extends XmlAdapter<String, Object>
/*     */   {
/*     */     public Object unmarshal(String s)
/*     */     {
/*  27 */       throw new UnsupportedOperationException();
/*     */     }
/*     */     
/*     */     public String marshal(Object o) {
/*  31 */       if (o == null) return null;
/*  32 */       return o.toString();
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   static
/*     */   {
/*  50 */     Map<Class, Class> b = new HashMap();
/*  51 */     b.put(Byte.TYPE, Byte.class);
/*  52 */     b.put(Short.TYPE, Short.class);
/*  53 */     b.put(Integer.TYPE, Integer.class);
/*  54 */     b.put(Long.TYPE, Long.class);
/*  55 */     b.put(Character.TYPE, Character.class);
/*  56 */     b.put(Boolean.TYPE, Boolean.class);
/*  57 */     b.put(Float.TYPE, Float.class);
/*  58 */     b.put(Double.TYPE, Double.class);
/*  59 */     b.put(Void.TYPE, Void.class);
/*     */     
/*  61 */     primitiveToBox = Collections.unmodifiableMap(b);
/*     */     
/*  63 */     Map<Class, Class> p = new HashMap();
/*  64 */     for (Map.Entry<Class, Class> e : b.entrySet()) {
/*  65 */       p.put(e.getValue(), e.getKey());
/*     */     }
/*  67 */     boxToPrimitive = Collections.unmodifiableMap(p);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public static void handlePrintConversionException(Object caller, Exception e, XMLSerializer serializer)
/*     */     throws SAXException
/*     */   {
/*  76 */     if ((e instanceof SAXException))
/*     */     {
/*     */ 
/*     */ 
/*  80 */       throw ((SAXException)e);
/*     */     }
/*  82 */     ValidationEvent ve = new PrintConversionEventImpl(1, e.getMessage(), new ValidationEventLocatorImpl(caller), e);
/*     */     
/*     */ 
/*  85 */     serializer.reportError(ve);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public static void handleTypeMismatchError(XMLSerializer serializer, Object parentObject, String fieldName, Object childObject)
/*     */     throws SAXException
/*     */   {
/*  94 */     ValidationEvent ve = new ValidationEventImpl(1, Messages.TYPE_MISMATCH.format(new Object[] { getTypeName(parentObject), fieldName, getTypeName(childObject) }), new ValidationEventLocatorExImpl(parentObject, fieldName));
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 102 */     serializer.reportError(ve);
/*     */   }
/*     */   
/*     */   private static String getTypeName(Object o) {
/* 106 */     return o.getClass().getName();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\RuntimeUtil.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */