/*     */ package org.codehaus.janino;
/*     */ 
/*     */ import java.io.FilterReader;
/*     */ import java.io.IOException;
/*     */ import java.io.PrintStream;
/*     */ import java.io.Reader;
/*     */ import java.io.StringReader;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class UnicodeUnescapeReader
/*     */   extends FilterReader
/*     */ {
/*     */   public UnicodeUnescapeReader(Reader in)
/*     */   {
/*  48 */     super(in);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public int read()
/*     */     throws IOException
/*     */   {
/*     */     int c;
/*     */     
/*     */ 
/*  60 */     if (this.unreadChar == -1) {
/*  61 */       c = this.in.read();
/*     */     } else {
/*  63 */       c = this.unreadChar;
/*  64 */       this.unreadChar = -1;
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*  69 */     if ((c != 92) || (this.oddPrecedingBackslashes)) {
/*  70 */       this.oddPrecedingBackslashes = false;
/*  71 */       return c;
/*     */     }
/*     */     
/*     */ 
/*  75 */     int c = this.in.read();
/*  76 */     if (c != 117) {
/*  77 */       this.unreadChar = c;
/*  78 */       this.oddPrecedingBackslashes = true;
/*  79 */       return 92;
/*     */     }
/*     */     
/*     */     do
/*     */     {
/*  84 */       c = this.in.read();
/*  85 */       if (c == -1) throw new UnicodeUnescapeException("Incomplete escape sequence");
/*  86 */     } while (c == 117);
/*     */     
/*     */ 
/*  89 */     char[] ca = new char[4];
/*  90 */     ca[0] = ((char)c);
/*  91 */     if (this.in.read(ca, 1, 3) != 3) throw new UnicodeUnescapeException("Incomplete escape sequence");
/*     */     try {
/*  93 */       return 0xFFFF & Integer.parseInt(new String(ca), 16);
/*     */     } catch (NumberFormatException ex) {
/*  95 */       throw new UnicodeUnescapeException("Invalid escape sequence \"\\u" + new String(ca) + "\"");
/*     */     }
/*     */   }
/*     */   
/*     */ 
/*     */   public int read(char[] cbuf, int off, int len)
/*     */     throws IOException
/*     */   {
/* 103 */     if (len == 0) return 0;
/* 104 */     int res = 0;
/*     */     do {
/* 106 */       int c = read();
/* 107 */       if (c == -1) break;
/* 108 */       cbuf[(off++)] = ((char)c);
/* 109 */       res++; } while (res < len);
/* 110 */     return res == 0 ? -1 : res;
/*     */   }
/*     */   
/*     */ 
/*     */   public static void main(String[] args)
/*     */     throws IOException
/*     */   {
/* 117 */     Reader r = new UnicodeUnescapeReader(new StringReader(args[0]));
/*     */     for (;;) {
/* 119 */       int c = r.read();
/* 120 */       if (c == -1) break;
/* 121 */       System.out.print((char)c);
/*     */     }
/* 123 */     System.out.println();
/*     */   }
/*     */   
/* 126 */   private int unreadChar = -1;
/* 127 */   private boolean oddPrecedingBackslashes = false;
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\UnicodeUnescapeReader.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */