package prefuse.util.ui;

import java.awt.Color;
import java.awt.Dimension;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import prefuse.util.force.Force;
import prefuse.util.force.ForceSimulator;

public class JForcePanel
  extends JPanel
{
  private ForcePanelChangeListener lstnr = new ForcePanelChangeListener(null);
  private ForceSimulator fsim;
  
  public JForcePanel(ForceSimulator paramForceSimulator)
  {
    this.fsim = paramForceSimulator;
    setBackground(Color.WHITE);
    initUI();
  }
  
  private void initUI()
  {
    setLayout(new BoxLayout(this, 1));
    Force[] arrayOfForce = this.fsim.getForces();
    for (int i = 0; i < arrayOfForce.length; i++)
    {
      Force localForce = arrayOfForce[i];
      Box localBox = new Box(1);
      for (int j = 0; j < localForce.getParameterCount(); j++)
      {
        JValueSlider localJValueSlider = createField(localForce, j);
        localJValueSlider.addChangeListener(this.lstnr);
        localBox.add(localJValueSlider);
      }
      String str = localForce.getClass().getName();
      str = str.substring(str.lastIndexOf(".") + 1);
      localBox.setBorder(BorderFactory.createTitledBorder(str));
      add(localBox);
    }
  }
  
  private static JValueSlider createField(Force paramForce, int paramInt)
  {
    double d1 = paramForce.getParameter(paramInt);
    double d2 = paramForce.getMinValue(paramInt);
    double d3 = paramForce.getMaxValue(paramInt);
    String str = paramForce.getParameterName(paramInt);
    JValueSlider localJValueSlider = new JValueSlider(str, d2, d3, d1);
    localJValueSlider.setBackground(Color.WHITE);
    localJValueSlider.putClientProperty("force", paramForce);
    localJValueSlider.putClientProperty("param", new Integer(paramInt));
    localJValueSlider.setPreferredSize(new Dimension(300, 30));
    localJValueSlider.setMaximumSize(new Dimension(300, 30));
    return localJValueSlider;
  }
  
  private static class ForcePanelChangeListener
    implements ChangeListener
  {
    public void stateChanged(ChangeEvent paramChangeEvent)
    {
      JValueSlider localJValueSlider = (JValueSlider)paramChangeEvent.getSource();
      float f = localJValueSlider.getValue().floatValue();
      Force localForce = (Force)localJValueSlider.getClientProperty("force");
      Integer localInteger = (Integer)localJValueSlider.getClientProperty("param");
      localForce.setParameter(localInteger.intValue(), f);
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\util\ui\JForcePanel.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */